;cc #ifndef QS_BASE_ACPI
;cc #define QS_BASE_ACPI

;
; ACPI common
;

;cc #pragma pack(1)

ACPI_RSDP       struc                     ;
;ct char
RSDP_Sign       db      8 dup (?)         ;
RSDP_Checksum   db      ?                 ;
;ct char
RSDP_OEMID      db      6 dup (?)         ;
RSDP_Revision   db      ?                 ;
RSDP_RSDTAddr   dd      ?                 ;
ACPI_RSDP       ends                      ;

ACPI_RSDP2      struc                     ;
RSDP_Hdr        ACPI_RSDP <?>             ;
RSDP_Length     dd      ?                 ;
RSDP_XSDTAddr   dq      ?                 ;
RSDP_Checksum2  db      ?                 ;
RSDP_Reserved   db      3 dup (?)         ;
ACPI_RSDP2      ends                      ;

ACPI_SDT_Header struc
ACPTH_Sign      dd      ?                 ;
ACPTH_Length    dd      ?                 ;
ACPTH_Revision  db      ?                 ;
ACPTH_Checksum  db      ?                 ;
;ct char
ACPTH_OEMID     db      6 dup (?)         ;
;ct char
ACPTH_OEMTabID  db      8 dup (?)         ;
ACPTH_OEMRev    dd      ?                 ;
ACPTH_CrID      dd      ?                 ;
ACPTH_CrRev     dd      ?                 ;
ACPI_SDT_Header ends

ACPI_RSDT       struc                     ;
RSDT_Header     ACPI_SDT_Header <?>       ;
RSDT_List       dd      1 dup (?)         ;
ACPI_RSDT       ends                      ;

ACPI_XSDT       struc                     ;
XSDT_Header     ACPI_SDT_Header <?>       ;
XSDT_List       dq      1 dup (?)         ;
ACPI_XSDT       ends                      ;

MCFG_Entry      struc                     ;
MCE_Base        dq      ?                 ;
MCE_SegGroup    dw      ?                 ;
MCE_StartBus    db      ?                 ;
MCE_EndBus      db      ?                 ;
MCE_Reserved    dd      ?                 ;
MCFG_Entry      ends                      ;

ACPI_MCFG       struc                     ;
MCFG_Reserved   dq      ?                 ;
MCFG_List       MCFG_Entry 1 dup <?>      ;
ACPI_MCFG       ends                      ;

SDTSIG_RSDT     equ     54445352h         ; Root System Description Table
SDTSIG_XSDT     equ     54445358h         ; Extended System Description Table
SDTSIG_FACP     equ     50434146h         ; Fixed ACPI Description Table
SDTSIG_FACS     equ     53434146h         ; Firmware ACPI Control Structure
SDTSIG_SSDT     equ     54445353h         ; Secondary System Description Table
SDTSIG_DSDT     equ     54445344h         ; Differentiated System Description Table
SDTSIG_MCFG     equ     4746434Dh         ; PCI Memory Mapped Configuration table

;cc #pragma pack()
;cc #endif // QS_BASE_ACPI
