;
; BOOTRM
; VGA related
;

VGA_ATR_ADDR    equ     03C0h
VGA_MISC_WRITE  equ     03C2h
VGA_SEQ_ADDR    equ     03C4h
VGA_PEL_MASK    equ     03C6h
VGA_DAC_READ    equ     03C7h
VGA_DAC_WRITE   equ     03C8h
VGA_MISC_READ   equ     03CCh
VGA_GRC_ADDR    equ     03CEh
VGA_CRT_ADDR    equ     03D4h
VGA_ATR_RESET   equ     03DAh

VGA_GDC_SR      equ     0
VGA_GDC_ESR     equ     1
VGA_GDC_CLRCMP  equ     2
VGA_GDC_ROTATE  equ     3
VGA_GDC_READMAP equ     4
VGA_GDC_MODE    equ     5
VGA_GDC_MISC    equ     6
VGA_GDC_DNTCARE equ     7
VGA_GDC_BITMASK equ     8

VGA_SEQ_RESET   equ     0
VGA_SEQ_CLKMODE equ     1
VGA_SEQ_MAPMASK equ     2
VGA_SEQ_CHARMAP equ     3
VGA_SEQ_MEMMODE equ     4

;cc #pragma pack()

; ---------------------------------------------------------------
; sequencer/crt/graphics controller write
; in: al - value
;     ah - index
SEQCRTGRF_WRITE macro
                local   wr_common                               ;
crt_write       label   near                                    ;
                mov     dx,VGA_CRT_ADDR                         ;
                jmp     wr_common                               ;
grc_write       label   near                                    ;
                mov     dx,VGA_GRC_ADDR                         ;
                jmp     wr_common                               ;
seq_write       label   near                                    ;
                mov     dx,VGA_SEQ_ADDR                         ;
wr_common:
                xchg    ah,al                                   ;
                out     dx,ax                                   ;
                xchg    ah,al                                   ; preserve values
                ret                                             ;
                endm 

; ---------------------------------------------------------------
; sequencer/crt/graphics controller read
; in:  ah - index
; out: al - value
SEQCRTGRF_READ  macro
                local   rd_common                               ;
crt_read        label   near                                    ;
                mov     dx,VGA_CRT_ADDR                         ;
                jmp     rd_common                               ;
grc_read        label   near                                    ;
                mov     dx,VGA_GRC_ADDR                         ;
                jmp     rd_common                               ;
seq_read        label   near                                    ;
                mov     dx,VGA_SEQ_ADDR                         ;
rd_common:
                mov     al,ah                                   ;
                out     dx,al                                   ;
                inc     dx                                      ;
                in      al,dx                                   ; ah preserved
                ret                                             ;
                endm 

; ---------------------------------------------------------------
; attribute controller write
; in: al - value
;     ah - index
; saves: ax,bx,cx,si,di                                         ;
ATR_WRITE       macro                                           ;
attr_write      label   near                                    ;
                push    cx                                      ;
                mov     cx,ax                                   ;
                mov     dx,VGA_ATR_RESET                        ;
                in      al,dx                                   ;
                mov     dx,VGA_ATR_ADDR                         ;
                in      al,dx                                   ;
                mov     ah,al                                   ;
                mov     al,ch                                   ;
                out     dx,al                                   ;
                mov     al,cl                                   ;
                out     dx,al                                   ;
                mov     al,ah                                   ;
                out     dx,al                                   ;
                mov     ax,cx                                   ;
                pop     cx                                      ;
                ret                                             ;
                endm                                            ;

; ---------------------------------------------------------------
; attribute controller read
; in:  ah - index
; out: al - value
; saves: ah,bx,cx,si,di                                         ;
ATR_READ        macro                                           ;
attr_read       label   near                                    ;
                push    cx                                      ;
                mov     dx,VGA_ATR_RESET                        ;
                in      al,dx                                   ;
                mov     dx,VGA_ATR_ADDR                         ;
                in      al,dx                                   ;
                xchg    al,ah                                   ; ah=orig
                out     dx,al                                   ;
                mov     cx,ax                                   ;
                inc     dx                                      ;
                in      al,dx                                   ;
                mov     ah,al                                   ;
                mov     dx,VGA_ATR_RESET                        ;
                in      al,dx                                   ;
                mov     dx,VGA_ATR_ADDR                         ;
                mov     al,ch                                   ;
                out     dx,al                                   ;
                mov     al,cl                                   ;
                xchg    al,ah                                   ;
                pop     cx                                      ;
                ret                                             ;
                endm                                            ;
