//
// QSINIT
// PE format definitions
// warning! this file is not equal to winnt.h PE defs!
//

#ifndef QS_PE_FMT
#define QS_PE_FMT

#include "qstypes.h"

#define IMAGE_DOS_SIGNATURE                 0x5A4D
#define IMAGE_NT_SIGNATURE              0x00004550
#define IMAGE_NT_OPTIONAL_HDR32_MAGIC        0x10B
#define IMAGE_NT_OPTIONAL_HDR64_MAGIC        0x20B
#define IMAGE_NUMBEROF_DIRECTORY_ENTRIES        16
#define IMAGE_SIZEOF_SHORT_NAME                  8
#define IMAGE_SIZEOF_SECTION_HEADER             40


#define IMAGE_DIRECTORY_ENTRY_EXPORT             0
#define IMAGE_DIRECTORY_ENTRY_IMPORT             1
#define IMAGE_DIRECTORY_ENTRY_RESOURCE           2
#define IMAGE_DIRECTORY_ENTRY_EXCEPTION          3
#define IMAGE_DIRECTORY_ENTRY_SECURITY           4
#define IMAGE_DIRECTORY_ENTRY_BASERELOC          5
#define IMAGE_DIRECTORY_ENTRY_DEBUG              6
#define IMAGE_DIRECTORY_ENTRY_COPYRIGHT          7
#define IMAGE_DIRECTORY_ENTRY_ARCHITECTURE       7
#define IMAGE_DIRECTORY_ENTRY_GLOBALPTR          8
#define IMAGE_DIRECTORY_ENTRY_TLS                9
#define IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG       10
#define IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT      11
#define IMAGE_DIRECTORY_ENTRY_IAT               12
#define IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT      13
#define IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR    14

#define IMAGE_SUBSYSTEM_UNKNOWN                  0
#define IMAGE_SUBSYSTEM_NATIVE                   1
#define IMAGE_SUBSYSTEM_WINDOWS_GUI              2
#define IMAGE_SUBSYSTEM_WINDOWS_CUI              3
#define IMAGE_SUBSYSTEM_OS2_CUI                  5
#define IMAGE_SUBSYSTEM_POSIX_CUI                7
#define IMAGE_SUBSYSTEM_NATIVE_WINDOWS           8
#define IMAGE_SUBSYSTEM_WINDOWS_CE_GUI           9
#define IMAGE_SUBSYSTEM_EFI_APPLICATION         10
#define IMAGE_SUBSYSTEM_EFI_BOOT_SERVICE_DRIVER	11
#define IMAGE_SUBSYSTEM_EFI_RUNTIME_DRIVER      12
#define IMAGE_SUBSYSTEM_EFI_ROM                 13
#define IMAGE_SUBSYSTEM_SAL_RUNTIME_DRIVER      13
#define IMAGE_SUBSYSTEM_XBOX                    14


#pragma pack(1)
typedef struct _IMAGE_FILE_HEADER {
   u16t                       Machine;
   u16t              NumberOfSections;
   u32t                 TimeDateStamp;
   u32t          PointerToSymbolTable;
   u32t               NumberOfSymbols;
   u16t          SizeOfOptionalHeader;
   u16t               Characteristics;
} IMAGE_FILE_HEADER, *PIMAGE_FILE_HEADER;

typedef struct _IMAGE_DATA_DIRECTORY {
   u32t                VirtualAddress;
   u32t                          Size;
} IMAGE_DATA_DIRECTORY, *PIMAGE_DATA_DIRECTORY;

typedef struct _IMAGE_OPTIONAL_HEADER {
   u16t                         Magic;
   u8t             MajorLinkerVersion;
   u8t             MinorLinkerVersion;
   u32t                    SizeOfCode;
   u32t         SizeOfInitializedData;
   u32t       SizeOfUninitializedData;
   u32t           AddressOfEntryPoint;
   u32t                    BaseOfCode;
   u32t                    BaseOfData;
   u32t                     ImageBase;
   u32t              SectionAlignment;
   u32t                 FileAlignment;
   u16t   MajorOperatingSystemVersion;
   u16t   MinorOperatingSystemVersion;
   u16t             MajorImageVersion;
   u16t             MinorImageVersion;
   u16t         MajorSubsystemVersion;
   u16t         MinorSubsystemVersion;
   u32t             Win32VersionValue;
   u32t                   SizeOfImage;
   u32t                 SizeOfHeaders;
   u32t                      CheckSum;
   u16t                     Subsystem;
   u16t            DllCharacteristics;
   u32t            SizeOfStackReserve;
   u32t             SizeOfStackCommit;
   u32t             SizeOfHeapReserve;
   u32t              SizeOfHeapCommit;
   u32t                   LoaderFlags;
   u32t           NumberOfRvaAndSizes;
   IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];
} IMAGE_OPTIONAL_HEADER32, *PIMAGE_OPTIONAL_HEADER32;

typedef struct _IMAGE_OPTIONAL_HEADER64 {
   u16t                         Magic;
   u8t             MajorLinkerVersion;
   u8t             MinorLinkerVersion;
   u32t                    SizeOfCode;
   u32t         SizeOfInitializedData;
   u32t       SizeOfUninitializedData;
   u32t           AddressOfEntryPoint;
   u32t                    BaseOfCode;
   u64t                     ImageBase;
   u32t              SectionAlignment;
   u32t                 FileAlignment;
   u16t   MajorOperatingSystemVersion;
   u16t   MinorOperatingSystemVersion;
   u16t             MajorImageVersion;
   u16t             MinorImageVersion;
   u16t         MajorSubsystemVersion;
   u16t         MinorSubsystemVersion;
   u32t             Win32VersionValue;
   u32t                   SizeOfImage;
   u32t                 SizeOfHeaders;
   u32t                      CheckSum;
   u16t                     Subsystem;
   u16t            DllCharacteristics;
   u64t            SizeOfStackReserve;
   u64t             SizeOfStackCommit;
   u64t             SizeOfHeapReserve;
   u64t              SizeOfHeapCommit;
   u32t                   LoaderFlags;
   u32t           NumberOfRvaAndSizes;
   IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];
} IMAGE_OPTIONAL_HEADER64, *PIMAGE_OPTIONAL_HEADER64;

typedef struct _IMAGE_DOS_HEADER {
   u16t                       e_magic;
   u16t                        e_cblp;
   u16t                          e_cp;
   u16t                        e_crlc;
   u16t                     e_cparhdr;
   u16t                    e_minalloc;
   u16t                    e_maxalloc;
   u16t                          e_ss;
   u16t                          e_sp;
   u16t                        e_csum;
   u16t                          e_ip;
   u16t                          e_cs;
   u16t                      e_lfarlc;
   u16t                        e_ovno;
   u16t                      e_res[4];
   u16t                       e_oemid;
   u16t                     e_oeminfo;
   u16t                    e_res2[10];
   u32t                      e_lfanew;
} IMAGE_DOS_HEADER,*PIMAGE_DOS_HEADER;

typedef struct _IMAGE_NT_HEADERS {
   u32t                     Signature;
   IMAGE_FILE_HEADER       FileHeader;
   IMAGE_OPTIONAL_HEADER32  OptHeader;
} IMAGE_NT_HEADERS32, *PIMAGE_NT_HEADERS32;

typedef struct _IMAGE_NT_HEADERS64 {
   u32t                     Signature;
   IMAGE_FILE_HEADER       FileHeader;
   IMAGE_OPTIONAL_HEADER64  OptHeader;
} IMAGE_NT_HEADERS64, *PIMAGE_NT_HEADERS64;

typedef struct _IMAGE_SECTION_HEADER {
   u8t  Name[IMAGE_SIZEOF_SHORT_NAME];
   union {
      u32t            PhysicalAddress;
      u32t                VirtualSize;
   } Misc;
   u32t                VirtualAddress;
   u32t                 SizeOfRawData;
   u32t              PointerToRawData;
   u32t          PointerToRelocations;
   u32t          PointerToLinenumbers;
   u16t           NumberOfRelocations;
   u16t           NumberOfLinenumbers;
   u32t               Characteristics;
} IMAGE_SECTION_HEADER, *PIMAGE_SECTION_HEADER;

#pragma pack()

#endif // QS_PE_FMT
