;
; QSINIT
; common constants
;

;cc #ifndef QSINIT_ASMDEFS
;cc #define QSINIT_ASMDEFS

          LOGBUF_SIZE    = 1000h                                ; internal log handler RM buffer
          DISKBUF_SIZE   = 8000h                                ; size of real mode disk i/o buffer
                                                                ; 56k max (pagemode.c), 32k is surely
                                                                ; assumed in many places
;cr #ifndef EFI_BUILD
ifndef EFI_BUILD
          QSINIT_SEGREAL = 9100h                                ; qsinit segment (CONSTANT!)
          OS2LDR_SEGREAL = 1000h                                ; initial os2ldr cs

          MFSDBASE       = 07C0h                                ; lowest MFSD phys address
          RIPLBASE       = 0800h                                ; lowest RIPL phys address

          QSM_STACK16    = 7168                                 ; internal 16-bit stack size
          QSM_STACK32    = 16384                                ; internal 32-bit stack size
;cc #if 0  // selectors in common & EFI build are different
          SELCODE        = 08h                                  ; TEXT16 code selector
          SELZERO        = 10h                                  ; selector of entire memory space
          SELCALLBACKDS  = 18h                                  ; callback DS selector
          SELREAL        = 20h                                  ; real mode attributes selector
; in many places assumed FLAT DS = FLAT CS + 8
          SEL32CODE      = 28h                                  ; 32bit CS based flat code
          SEL32DATA      = 30h                                  ; 32bit CS based flat data
          SELDATA        = 38h                                  ; TEXT16 data selector
;cc #endif
          GUARD0_AREA    = 400000h                              ; 4Mb

          GETTIME_ERRV   = 4A210000h                            ; 1/1/2017
          LDI_NAME_LEN   = 25
;cr #else // EFI_BUILD
else
          LDI_NAME_LEN   = 128
;cr #endif // EFI_BUILD
endif
          INIT_SYS_AREA  = 8000000h                             ; 128 Mb

          STO_BUF_LEN    = 14                                   ; internal storage buffer size
          STOINIT_ESIZE  = 20                                   ; internal storage entry size

          MAX_QS_DISK    = 24                                   ; number of supported fdd+hdd
          MAX_QS_FLOPPY  = 2                                    ; number of supported fdds

          MFSD_NAME_LEN  = 128                                  ; max length of micro-FSD name
;cc #endif // QSINIT_ASMDEFS
