;
; QSINIT
; 16bit tiny print subset
; note: used both in qsinit & doshlp binary
;
; void far __cdecl printf16(char far *fmt,...);
; or
; typedef void far __cdecl (*bcharoutf)(char);
; void far __cdecl bprintf16(bcharoutf charout, char far *fmt,...);
;
;   %x       - print argument as a hex word (16 bit)
;   %d       - print argument as decimal word (16 bit)
;   %c       - print argument as ascii character
;   %b[nn]   - print argument as hex byte (far 16 bit, nn bytes)
;   %s[nn]   - print argument as string (far 16 bit, nn chars)
;   %ld      - print argument as decimal dword (32 bit)
;   %lx      - print argument as a hex dword (32 bit)
;
;   \n \t - supported in DOSHLP_BUILD/JFSMICRO_BUILD only.
;

                include inc/qstypes.inc
; ----------------------------------
ifdef DOSHLP_BUILD                                              ;
                include inc/segdef.inc                          ; segments
                FULLABC = 0                                     ;
                SEQON   = 1                                     ;
                NEARFN  = 0                                     ;
DOSHLP_CODE     segment                                         ;
                extrn   DHSerOutPrn:near
print_char macro                                                ;
                call    DHSerOutPrn                             ;
endm                                                            ;
endif                                                           ;
; ----------------------------------
ifdef JFSMICRO_BUILD                                            ;
                FULLABC = 0                                     ;
                SEQON   = 1                                     ;
                NEARFN  = 1                                     ;
                include jfs/jsegdef.inc                         ; segments
JCODE_TEXT      segment                                         ;
                extrn   prnchar:near                            ;
print_char macro                                                ;
                call    prnchar                                 ;
endm                                                            ;
endif                                                           ;
; ----------------------------------
ifdef LDR_BUILD
                include inc/segdef.inc                          ; segments
                FULLABC = 1                                     ;
                SEQON   = 0                                     ;
                NEARFN  = 0                                     ;
TEXT16          segment                                         ;
                extrn   _seroutchar_w:near                      ;
print_char macro                                                ;
                push    ax                                      ;
                call    _seroutchar_w                           ;
endm                                                            ;
endif                                                           ;
; ----------------------------------
                assume  cs:nothing, ds:nothing, es:nothing, ss:nothing
                public  _printf16
ifndef JFSMICRO_BUILD                                           ;
                public  _bprintf16                              ;
if NEARFN                                                       ;
_bprintf16      label   near                                    ;
else                                                            ;
_bprintf16      label   far                                     ;
endif                                                           ;
                push    bp                                      ;
                mov     bp,sp                                   ;
                push    1                                       ; use charout fn
                pushf                                           ;
                pushad                                          ;
                push    ds                                      ;
                lds     si,[bp+10-NEARFN*2]                     ; fmt string
                mov     di,14-NEARFN*2                          ; parameters
                jmp     @@dhp_common                            ;
endif                                                           ;
if NEARFN                                                       ;
_printf16       proc    near                                    ;
else                                                            ;
_printf16       proc    far                                     ;
endif                                                           ;
                push    bp                                      ;
                mov     bp,sp                                   ;
                push    0                                       ; use serial print
                pushf                                           ;
                pushad                                          ;
                push    ds                                      ;
                lds     si,[bp+6-NEARFN*2]                      ; fmt string
                mov     di,10-NEARFN*2                          ; parameters
@@dhp_common:
                push    gs                                      ;
                xor     ebx,ebx                                 ; 3 high bytes must be cleared!
@@dhp_charloop_ah:
                xor     ah,ah                                   ; clean prev. char
@@dhp_charloop:
                lodsb                                           ;
                or      al,al                                   ;
                jz      @@dhp_exit                              ;
                cmp     al,'%'                                  ;
                jnz     @@dhp_fmtprn                            ;
@@dhp_fmtarg:
                lodsb                                           ;
                or      al,al                                   ;
                jz      @@dhp_exit                              ;
                cmp     al,'s'                                  ;
                jz      @@dhp_string                            ;
                cmp     al,'x'                                  ;
                jz      @@dhp_hex4                              ;
                cmp     al,'d'                                  ;
                jz      @@dhp_short                             ;
                cmp     al,'c'                                  ;
                jz      @@dhp_char                              ;
                cmp     al,'b'                                  ;
                jz      @@dhp_binary                            ;
                cmp     al,'l'                                  ;
                jnz     @@dhp_fmtprn                            ;
                lodsb                                           ;
                or      al,al                                   ; %lx %ld
                jz      @@dhp_exit                              ;
                cmp     al,'x'                                  ;
                jz      @@dhp_hex8                              ;
                cmp     al,'d'                                  ;
                jnz     @@dhp_charloop_ah                       ;
@@dhp_dword:
                mov     ecx,[bp][di]                            ; print %ld
                add     di,4                                    ;
                jmp     @@dhp_unsigned                          ;
@@dhp_short:
                xor     ecx,ecx                                 ;
                mov     cx,[bp][di]                             ; print %d
                add     di,2                                    ;
@@dhp_unsigned:
                mov     ebx,1000000000                          ;
                push    si                                      ;
                xor     si,si                                   ;
@@dhp_uns_loop:
                mov     eax,ecx                                 ;
                xor     edx,edx                                 ;
                div     ebx                                     ;
                mov     ecx,edx                                 ;
                or      si,ax                                   ;
                jz      @@dhp_uns_hi                            ;
@@dhp_uns_zero:
                add     al,'0'                                  ;
                call    @@dhp_printchar                         ;
                inc     si                                      ; chars printed flag
@@dhp_uns_hi:
                mov     eax,0CCCCCCCDh                          ; div 10
                mul     ebx                                     ;
                shr     edx,3                                   ;
                mov     ebx,edx                                 ;
                jnz     @@dhp_uns_loop                          ;
                xor     al,al                                   ;
                or      si,si                                   ; no chars printed?
                jz      @@dhp_uns_zero                          ; print at least one
                pop     si                                      ;
                jmp     @@dhp_charloop_ah                       ;
@@dhp_exit:
                pop     gs                                      ;
                pop     ds                                      ;
                popad                                           ;
                popf                                            ;
                mov     sp,bp                                   ;
                pop     bp                                      ;
                ret                                             ;
if SEQON
@@dhp_escape:
                mov     dl,[si]                                 ; \n \t
                or      dl,dl                                   ; if not - out
                jz      @@dhp_fmt_noeol                         ; both \ and symbol
                cmp     dl,'n'                                  ;
                jz      @@dhp_escape_n                          ;
                cmp     dl,'t'                                  ;
                jnz     @@dhp_fmt_noeol                         ;
                mov     al,9                                    ;
                call    @@dhp_printchar                         ;
                inc     si                                      ;
                jmp     @@dhp_charloop_ah                       ;
@@dhp_escape_n:
                inc     si                                      ;
                mov     al,13                                   ;
                call    @@dhp_printchar                         ;
                mov     al,10                                   ;
                call    @@dhp_printchar                         ;
                jmp     @@dhp_charloop_ah                       ;
endif
@@dhp_char:
                mov     al,[bp][di]                             ; print %c
                add     di,2                                    ;
@@dhp_fmtprn:
if SEQON
                cmp     al,'\'                                  ;
                jz      @@dhp_escape                            ;
endif
                cmp     al,10                                   ; print char
                jnz     @@dhp_fmt_noeol                         ;
                cmp     ah,13                                   ;
                jz      @@dhp_fmt_noeol                         ;
                mov     al,13                                   ;
                dec     si                                      ;
@@dhp_fmt_noeol:
                mov     ah,al                                   ;
                call    @@dhp_printchar                         ;
                jmp     @@dhp_charloop                          ;
@@dhp_printchar:
                test    byte ptr [bp-2],1                       ;
                jz      @@dhp_printchar_serial                  ;
                push    ax                                      ; save regs
                push    dx                                      ; according to
                push    ecx                                     ; 16-bit call.conv
                push    ebx                                     ;
                push    es                                      ;
                push    ax                                      ;
                call    far ptr [bp+6-NEARFN*2]                 ;
                pop     ax                                      ; cdecl
                pop     es                                      ;
                pop     ebx                                     ;
                pop     ecx                                     ;
                pop     dx                                      ;
                pop     ax                                      ;
                retn                                            ;
@@dhp_printchar_serial:
                print_char                                      ;
                retn                                            ;
@@dhp_string:
                call    @@dhp_getint                            ; print %s
                push    si                                      ;
                lgs     si,[bp][di]                             ;
                add     di,4                                    ;
@@dhp_stringloop:
                lods    byte ptr gs:[si]                        ;
                or      al,al                                   ;
                jz      @@dhp_stringend                         ;
                call    @@dhp_printchar                         ;
                loop    @@dhp_stringloop                        ;
@@dhp_stringend:
                pop     si                                      ;
                jmp     @@dhp_charloop_ah                       ;
@@dhp_hex8:
                add     al,2                                    ; print %x, %lx
@@dhp_hex4:
                sub     al,'x'-2                                ;
                mov     cl,al                                   ; number of bytes
                xor     ch,ch                                   ;
                add     di,cx                                   ;
                push    di                                      ;
@@dhp_hexloop:
                dec     di                                      ;
                mov     dl,[bp][di]                             ;
                xor     dh,dh                                   ;
                stc                                             ;
@@dhp_hexloopchar:
                rcl     dx,4                                    ;
                and     dh,0Fh                                  ;
                mov     bl,dh                                   ;
                mov     al,cs:dhp_ABCDEF[bx]                    ;
                call    @@dhp_printchar                         ;
                cmp     dl,80h                                  ;
                clc                                             ;
                jnz     @@dhp_hexloopchar                       ;
                loop    @@dhp_hexloop                           ;
                pop     di                                      ;
                jmp     @@dhp_charloop_ah                       ;
@@dhp_binary:
                call    @@dhp_getint                            ; print %b
                push    si                                      ;
                lgs     si,[bp][di]                             ;
                add     di,4                                    ;
                xor     dh,dh                                   ;
                or      ax,ax                                   ;
                jz      @@dhp_binloop                           ;
                neg     cx                                      ; make 1 from -1
@@dhp_binloop:
                lods    byte ptr gs:[si]                        ;
                mov     dl,al                                   ;
                xor     dh,dh                                   ;
                stc                                             ;
@@dhp_binloopbyte:
                rcl     dx,4                                    ;
                and     dh,0Fh                                  ;
                mov     bl,dh                                   ;
                mov     al,cs:dhp_ABCDEF[bx]                    ;
                call    @@dhp_printchar                         ;
                cmp     dl,80h                                  ;
                clc                                             ;
                jnz     @@dhp_binloopbyte                       ;
                mov     al,' '                                  ;
                call    @@dhp_printchar                         ;
                loop    @@dhp_binloop                           ;
                pop     si                                      ;
                jmp     @@dhp_charloop_ah                       ;
; get int in cx, or FFFFh. return ax=0 if cx<>-1
@@dhp_getint:
                xor     cx,cx                                   ;
                xor     ah,ah                                   ;
@@dhp_getint_loop:
                lodsb                                           ;
                or      al,al                                   ;
                jz      @@dhp_getint_end                        ;
                sub     al,'0'                                  ;
                jc      @@dhp_getint_end                        ;
                cmp     al,10                                   ;
                jnc     @@dhp_getint_end                        ;
                imul    cx,cx,10                                ;
                add     cx,ax                                   ;
                jmp     @@dhp_getint_loop                       ;
@@dhp_getint_end:
                dec     si                                      ;
                or      cx,cx                                   ; return -1
                setz    al                                      ; if cx was zero
                neg     ax                                      ;
                or      cx,ax                                   ;
                retn                                            ;
dhp_ABCDEF      label   byte                                    ;
if FULLABC
                public  _alphabet
_alphabet       label   near
                db      '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'  ; used in utoa
else
                db      '0123456789ABCDEF'                      ;
endif
_printf16       endp

ifdef DOSHLP_BUILD                                              ;
DOSHLP_CODE     ends                                            ;
endif                                                           ;
ifdef JFSMICRO_BUILD                                            ;
JCODE_TEXT      ends                                            ;
endif                                                           ;
ifdef LDR_BUILD
TEXT16          ends                                            ;
endif                                                           ;
                end
