;
; QSINIT
; help calls, 16-bit part
; --------------------------------------------------------------------
; 16 & 32 function must be separated, because wasm makes wrong 16-bit
; offsets when import 16-bit data

                NOSTORSAVE  = 1
                include inc/segdef.inc
                include inc/seldesc.inc
                include inc/qstypes.inc
                include inc/serial.inc
                include inc/debug.inc
                include inc/basemac.inc
                include inc/vbedata.inc
                include inc/biosdata.inc
                include inc/vgadef.inc
                include inc/cpudef.inc

;                INIT_COM_PORT = 2F8h
                INIT_COM_PORT = 0

DATA16          segment                                         ;
                extrn   _logbufseg:word                         ;
                extrn   _DiskBufRM_Seg:word                     ;
                extrn   _syslapic:dword                         ;
                extrn   _apic_tmr_vnum:byte                     ;
                extrn   org_int16h:dword                        ;
                public  _ComPortAddr, _BaudRate, _lowmem        ;
                public  _logrmbuf, _logrmpos, _page0_fptr       ;
                public  rm_timer_ofs, rm_spur_ofs, syslapic_p   ;
                public  apic_tmr_rcnt, apic_tmr_reoi, fontseg   ;
                align   4                                       ;
_logrmbuf       dd      0                                       ;
_BaudRate       dd      BD_115200                               ; current dbport baud rate
_ComPortAddr    dw      INIT_COM_PORT                           ; and address
_logrmpos       dw      0                                       ;

ifdef INITDEBUG
vio_out_proc    dw      offset printchar_rm                     ; vio prn char for
                dw      offset printchar_pm                     ; RM and PM
endif
rm_timer_ofs    dw      offset rm_timer                         ;
rm_spur_ofs     dw      offset rm_spurious                      ;
apic_tmr_rcnt   dw      0                                       ; counters
apic_tmr_reoi   dw      0                                       ;
syslapic_p      dd      0                                       ; physical addr

mini_gdt        desctab_s <0,0,0,0,0,0>                         ;
                desctab_s <0FFFFh,0,0,D_DATA0,D_DBIG or D_GRAN4K or D_AVAIL or 0Fh,0>
mini_gdt_ptr    dw      $-mini_gdt-1, offset mini_gdt, 0, 0     ;

; in non-page mode FLAT DS has no 0 page (up-down selector!).
; in page mode, zero page mapped as r/o, and separately as r/w.
; This is the actual far32 pointer for page 0 access, this value updated
; by START module when it turns on PAE (or by this module when it starts
; page mode itself - see pagemode.c).
_page0_fptr     dd      0                                       ;
                dd      SELZERO                                 ;
; assumed to be here!!! (&page0_fptr + 8)
fontseg         dw      0                                       ;
_lowmem         db      0                                       ;
DATA16          ends                                            ;

_BSS16          segment
                public  _storage_w                              ;
_storage_w      db      STO_BUF_LEN * STOINIT_ESIZE dup(?)      ;
_storage_w_end  label   near                                    ;
                public  _mfsd_openname, _mfsd_fsize             ;
_mfsd_openname  db      MFSD_NAME_LEN dup(?)                    ;
_mfsd_fsize     dd      ?                                       ;
_BSS16          ends

                extrn   enablea20:near                          ;

;================================================================
; warning! functions below do not save registers because called
;          only from protected mode!


TEXT16          segment
                assume  cs:G16, ds:G16, es:nothing, ss:G16

                public  _getkeyflags
_getkeyflags    proc    far                                     ;
                mov     ah,02h                                  ; read keyboard status
                int     16h                                     ;
                push    ax                                      ;
                mov     ah,12h                                  ;
                int     16h                                     ;
                pop     cx                                      ;
                mov     al,cl                                   ;
                ret                                             ;
_getkeyflags    endp

; set keyboard rate and delay
;----------------------------------------------------------------
                public  _setkeymode                             ;
_setkeymode     proc    far                                     ;
                mov     bp,sp                                   ;
                mov     ax,0305h                                ;
                mov     bx,[bp+4]                               ;
                int     16h                                     ;
                ret     4                                       ;
_setkeymode     endp                                            ;


; get active vertical display end (# of scan lines)
; ---------------------------------------------------------------
; ret: ax - value
get_vde         proc    near                                    ;
                mov     ah,12h                                  ; low 8 bit
                call    crt_read                                ;
                movzx   cx,al                                   ;
                mov     ah,7                                    ; bit 9 & 10
                call    crt_read                                ;
                mov     ah,al                                   ;
                shr     ah,1                                    ;
                and     ah,1                                    ;
                shr     al,5                                    ;
                and     al,2                                    ;
                or      ah,al                                   ;
                xor     al,al                                   ;
                add     ax,cx                                   ;
                inc     ax                                      ;
                ret                                             ;
get_vde         endp                                            ;

                SEQCRTGRF_WRITE
                SEQCRTGRF_READ

; set 80x25, 80x43, 80x50 and 80x60 text modes
;----------------------------------------------------------------
; [sp+4]  1 - 350 lines, 2 - 400, 6 - 480 lines
; [sp+5]  0 - 8x8 font, 2 - 8x16 font
; note that it also called from start.asm in Verbose build!
                public  _settextmode                            ;
_settextmode    proc    far                                     ;
                mov     bp,sp                                   ;
                mov     ax,1203h                                ; drop 480 flag
                and     al,[bp+4]                               ;
                mov     bl,30h                                  ; 350/400 lines
                int     10h                                     ;
                mov     ax,0003h                                ;
                int     10h                                     ;
                mov     ax,1112h                                ; font height
                add     al,[bp+5]                               ;
                xor     bl,bl                                   ;
                int     10h                                     ;
                mov     ax,1003h                                ; blink off
                xor     bx,bx                                   ;
                mov     fs,bx                                   ; fs=0
                int     10h                                     ;
                
                mov     di,400h                                 ;
                mov     bp,sp                                   ; bios can destroy it
                mov     al,[bp+4]                               ;
                test    al,4                                    ; 80x60
                jnz     @@setmode_480                           ;
                cmp     al,1                                    ; 80x43?
                jnz     @@setmode_ok                            ;
; verify that 80x43 was not set as 80x50 (VBox up to 7.x problem)
; then try to set 80x43 via CRT (this can be a common bug, not VBox only,
; since 80x43 is rare mode);
; all registers are good, just need to change a number of scan lines
                cmp     fs:[di].BDA_VRows,49                    ;
                jnz     @@setmode_ok                            ;

                mov     ax,125Dh                                ; reg 12h update
                call    crt_write                               ;
@@setmode_updbios:
                call    get_vde                                 ; calc rows
                shr     ax,3                                    ;
                mov     dl,al                                   ;
                dec     dl                                      ;
                mov     fs:[di].BDA_VRows,dl                    ;

                mul     fs:[di].BDA_VCols                       ; calc page size
                shl     ax,1                                    ;
                add     ax,7FFh                                 ; round to 2k
                and     ax,not 7FFh                             ;
                mov     fs:[di].BDA_VPageSize,ax                ;
@@setmode_ok:
                ret     4                                       ;
@@setmode_480:
                cli                                             ; set 80x60
                mov     dx,VGA_MISC_WRITE                       ;
                mov     al,0E7h                                 ; negative VSYNC polarity
                out     dx, al                                  ; 480 lines

                mov     ax,110Ch                                ;
                call    crt_write                               ; R11 (v ret end + protect)
                mov     ax,0B06h                                ;
                out     dx,ax                                   ; R06 (v total)
                mov     ax,3E07h                                ;
                out     dx,ax                                   ; R07 (overflow)
                mov     ax,4709h                                ;
                out     dx,ax                                   ; R09 (max scan line)
                mov     ax,060Ah                                ;
                out     dx,ax                                   ; R0A (cursor start)
                mov     ax,070Bh                                ;
                out     dx,ax                                   ; R0B (cursor end)
                mov     ax,0EA10h                               ;
                out     dx,ax                                   ; R10 (v ret start)
                mov     ax,0DF12h                               ;
                out     dx,ax                                   ; R12 (v disp enable end)
                mov     ax,0E715h                               ;
                out     dx,ax                                   ; R15 (v blank start)
                mov     ax,0416h                                ;
                out     dx,ax                                   ; R16 (v blank end)
                mov     ax,8C11h                                ;
                out     dx,ax                                   ; R11 (v ret end + protect)
                sti                                             ;
                jmp     @@setmode_updbios                       ;
_settextmode    endp                                            ;

; is screen in text mode? (common or vesa)
;----------------------------------------------------------------
                public  _istextmode                             ;
_istextmode     proc    far                                     ;
                mov     ax,4F03h                                ;
                int     10h                                     ;
                or      ah,ah                                   ;
                jnz     @@ismode_old                            ;
                and     bx,1FFFh                                ; zero flags
                cmp     bx,100h                                 ;
                jc      @@ismode_old                            ;
                mov     cx,bx                                   ;
                mov     es,_DiskBufRM_Seg                       ;
                xor     di,di                                   ;
                mov     ax,4F01h                                ; check vesa mode
                int     10h                                     ;
                cmp     ax,004Fh                                ;
                jnz     @@ismode_old                            ;
                mov     ax,es:[di].ModeAttributes               ;
                and     ax,VSMI_BIOSSUPP or VSMI_GRAPHMODE      ;
                cmp     ax,VSMI_BIOSSUPP                        ;
                setz    al                                      ;
                ret                                             ;
@@ismode_old:
                mov     ah,0Fh                                  ;
                int     10h                                     ;
                cmp     al,4                                    ; <=3?
                setc    al                                      ;
                ret                                             ;
_istextmode     endp                                            ;

; reset mode to 80x25 or clear screen if mode was not changed.
; this check used to prevent screen blinking on unnessesary mode switch
;----------------------------------------------------------------
                public  _checkresetmode                         ;
_checkresetmode proc    far                                     ;
                push    fs                                      ; warning! args in stack!
                mov     ax,4F03h                                ;
                int     10h                                     ;
                or      ah,ah                                   ;
                jnz     @@crmode_old                            ;
                cmp     bx,100h                                 ;
                jnc     @@crmode_reset                          ;
@@crmode_old:
                mov     ah,0Fh                                  ;
                int     10h                                     ;
                cmp     al,3                                    ;
                jnz     @@crmode_reset                          ;

                xor     ax,ax                                   ;
                mov     fs,ax                                   ;
ifndef INITDEBUG
                mov     al,fs:[484h]                            ; 25 lines?
                cmp     al,24                                   ; do not check in
                jnz     @@crmode_reset                          ; verbose build!
endif
                mov     ax,fs:[44Ah]                            ;
                cmp     ax,80                                   ; 80 cols?
                jz      @@crmode_ok                             ;
@@crmode_reset:
                mov     ax,1202h                                ;
                mov     bl,30h                                  ;
                int     10h                                     ;
                mov     ax,0003h                                ;
                int     10h                                     ;
                xor     bl,bl                                   ;
                mov     ax,1114h                                ; reset font after
                int     10h                                     ; EGA/VGA text mode
                jmp     @@crmode_exit                           ;
@@crmode_ok:
                mov     bp,sp                                   ; need clear?
                mov     ax,[bp+6]                               ;
                or      ax,ax                                   ;
                jz      @@crmode_exit                           ;
                mov     ax,40h                                  ; clear screen
                mov     es,ax                                   ;
                mov     dh,es:[84h]                             ;
                mov     dl,es:[4Ah]                             ;
                dec     dl                                      ;
                xor     cx,cx                                   ;
                mov     ax,0600h                                ;
                mov     bh,07h                                  ;
                int     10h                                     ;
@@crmode_exit:
                mov     ax,1003h                                ; set intensity
                xor     bx,bx                                   ; (EGA BIOS)
                int     10h                                     ;
                pop     fs                                      ;
                ret     4                                       ;
_checkresetmode endp                                            ;

; test something
;----------------------------------------------------------------
; in : [sp+4] = function index
; out: dx:ax  = -1 - invalid index, else function result
                public  _biostest
_biostest       proc    far
                mov     bp,sp                                   ;
                mov     bx,[bp+4]                               ;
                cmp     bx,biostestsize                         ;
                jnc     @@bt_err                                ;
                shl     bx,1                                    ;
                jmp     word ptr @@bt_offsets[bx]               ;
@@bt_err:
                mov     ax,-1                                   ;
                mov     dx,ax                                   ;
                ret                                             ;
@@bt_apm:
                mov     ax,5300h                                ; APM presence
                xor     bx,bx                                   ;
                int     15h                                     ; ret
                setc    dl                                      ; 0x100xx on err
                jnc     @@bt_apm_1                              ;
                mov     al,ah                                   ;
                xor     ah,ah                                   ;
@@bt_apm_1:
                xor     dh,dh                                   ; 0x00ver on ok
                ret                                             ;
@@bt_pci:
                mov     ax,0B101h                               ; PCI presence
                xor     edi,edi                                 ;
                int     1Ah                                     ;
                jc      @@bt_pci_fail                           ;
                cmp     edx,020494350h                          ;
                jnz     @@bt_pci_fail                           ;
                mov     ah,cl                                   ;
                mov     dx,bx                                   ;
                ret                                             ;
@@bt_pci_fail:
                xor     ax,ax                                   ;
                xor     dx,dx                                   ;
                ret                                             ;
@@bt_keyread:
                mov     ah,11h                                  ;
                int     16h                                     ;
                jz      @@bt_pci_fail                           ;
                mov     ah,10h                                  ;
                int     16h                                     ;
                push    ax                                      ;
                mov     ah,02h                                  ; keyboard status
                int     16h                                     ;
                push    ax                                      ;
                mov     ah,12h                                  ;
                int     16h                                     ;
                pop     dx                                      ;
                mov     dh,ah                                   ; dx - status
                pop     ax                                      ; ax - key code
                ret                                             ;
@@bt_int11h:
                int     11h                                     ;
                xor     dx,dx                                   ;
                ret                                             ;
@@bt_offsets:
                dw      offset @@bt_apm                         ;
                dw      offset @@bt_pci                         ;
                dw      offset @@bt_keyread                     ;
                dw      offset @@bt_int11h                      ;
@@bt_tabend:
biostestsize    equ     (offset @@bt_tabend - offset @@bt_offsets) shr 1
_biostest       endp

; apm poweroff/suspend
;----------------------------------------------------------------
; in : [sp+4] = 02 - suspend, 03 - power off
; out: exit
                public  _poweroffpc
_poweroffpc     proc    far
                mov     bp,sp                                   ;
                mov     ax,5300h                                ;
                xor     bx,bx                                   ;
                int     15h                                     ;
                dbg16print <"5300: %x %x %x",10>,<cx,bx,ax>
                jc      @@hlt_loop                              ;
                push    ax                                      ;

                mov     ax,5301h                                ;
                xor     bx,bx                                   ;
                int     15h                                     ;
                jnc     @@hlt_connected                         ;
                cmp     ah,2                                    ; connected?
                jnz     @@hlt_loop                              ;
@@hlt_connected:
                pop     cx                                      ;
                cmp     cx,100h                                 ;
                mov     bx,-1                                   ; FFFF for APM 1.0
                jz      @@hlt_ver100                            ;
                mov     ax,530Eh                                ; set org version
                xor     bx,bx                                   ;
                int     15h                                     ;
                dbg16print <"530E: %x",10>,<ax>
                mov     bx,1                                    ;
@@hlt_ver100:
                mov     ax,5308h                                ; enable APM
                mov     cx,1                                    ;
                int     15h                                     ;
                dbg16print <"5308: %x",10>,<ax>
                mov     ax,530Fh                                ; engage APM
                mov     bx,1                                    ;
                mov     cx,bx                                   ;
                int     15h                                     ;
                dbg16print <"530F: %x",10>,<ax>
                mov     ax,530Dh                                ; enable device APM
                mov     bx,1                                    ;
                mov     cx,bx                                   ;
                int     15h                                     ;
                dbg16print <"530D: %x",10>,<ax>

                mov     ax,5307h                                ;
                mov     cx,[bp+4]                               ;
                mov     bx,1                                    ;
                int     15h                                     ;
                dbg16print <"5307: %x",10>,<ax>

                mov     ax,5304h                                ; disconnect
                xor     bx,bx                                   ;
                int     15                                      ;
@@hlt_loop:
                mov     sp,bp                                   ;
                ret                                             ;
_poweroffpc     endp

;----------------------------------------------------------------
;void* __stdcall memmove16(void *dst, const void *src, u32t length);
                public  _memmove16                              ;
_memmove16      proc    near                                    ;
@@mmv16_dst     =  4                                            ;
@@mmv16_src     =  6                                            ;
@@mmv16_length  =  8                                            ;
                push    bp                                      ;
                mov     bp,sp                                   ;
                push    es                                      ;
                push    cx                                      ;
                push    si                                      ;
                push    ds                                      ;
                pop     es                                      ;
                mov     si,[bp+@@mmv16_src]                     ;
                push    di                                      ;
                mov     di,[bp+@@mmv16_dst]                     ;
                mov     cx,[bp+@@mmv16_length]                  ;
                test    cx,cx                                   ;
                jz      @@mmv16_move0                           ;
                cmp     si,di                                   ;
                jae     @@mmv16_forward                         ;
                std                                             ; move backward
                add     si,cx                                   ;
                add     di,cx                                   ;
                mov     ax,cx                                   ;
                and     cx,3                                    ;
                dec     si                                      ;
                dec     di                                      ;
            rep movsb                                           ;
                mov     cx,ax                                   ;
                shr     cx,2                                    ;
                jz      @@mmv16_move0                           ;
                sub     si,3                                    ;
                sub     di,3                                    ;
            rep movsd                                           ;
                jmp     @@mmv16_move0                           ;
@@mmv16_forward:
                cld                                             ; move forward
@@mmv16_align:
                test    di,3                                    ; make sure data is aligned
                jz      @@mmv16_aligned                         ;
                movsb                                           ;
                dec     cx                                      ;
                jz      @@mmv16_move0                           ;
                jmp     @@mmv16_align                           ;
@@mmv16_aligned:
                mov     ax,cx                                   ;
                shr     cx,2                                    ;
                and     al,3                                    ;
            rep movsd                                           ;
                mov     cl, al                                  ;
            rep movsb                                           ;
@@mmv16_move0:
                pop     di                                      ;
                pop     si                                      ;
                cld                                             ;
                pop     cx                                      ;
                pop     es                                      ;
                mov     ax,[bp+@@mmv16_dst]                     ;
                mov     sp,bp                                   ;
                pop     bp                                      ;
                ret     6                                       ;
_memmove16      endp

ifdef INITDEBUG
                public  earlyserinit
if INIT_COM_PORT GT 0
setbaudrate     proc    near                                    ;
                push    eax                                     ;
                push    bx                                      ;
                push    ecx                                     ;
                push    edx                                     ;
                mov     ecx,_BaudRate                           ;
                mov     ax,CLOCK_RATEL                          ;
                shl     eax,16                                  ;
                mov     ax,CLOCK_RATEH                          ;
                xor     edx,edx                                 ;
                div     ecx                                     ;
                mov     bx,ax                                   ;
; set divisor-latch access bit
                mov     dx,_ComPortAddr                         ;
                or      dx,dx                                   ; if port not found
                jz      @@SBR1                                  ; then exit
                add     dx,COM_LCR                              ;
                in      al,dx                                   ;
                or      al,LC_DLAB                              ;
                out     dx,al                                   ;
; 
                add     dx,COM_DLM-COM_LCR                      ; set divisor-latch value.
                mov     al,bh                                   ;
                out     dx,al                                   ;
                dec     dx                                      ;
                mov     al,bl                                   ;
                out     dx,al                                   ;

                add     dx,COM_LCR-COM_DLL                      ;
                mov     al,3                                    ;
                out     dx,al                                   ;
@@SBR1:
                pop     edx                                     ;
                pop     ecx                                     ;
                pop     bx                                      ;
                pop     eax                                     ;
                ret                                             ;
setbaudrate     endp                                            ;

earlyserinit    proc    near
                push    dx
                push    ax
                mov     dx,_ComPortAddr                         ;
                add     dx,COM_MCR                              ;
                in      al,dx                                   ;
                or      al,3                                    ;
                out     dx,al                                   ;
                call    setbaudrate                             ;
                pop     ax
                pop     dx
                ret
earlyserinit    endp
else
; init com port value is 0, there is no reason to link all above ...
earlyserinit    proc    near
                ret
earlyserinit    endp
endif
endif

;
; new char appends to the last line in realmode log buffer.
; zero assumed at _logbufseg pos (end of string char)
; if char prior to zero is \n - then a new log line started
;
                public  _seroutchar_w
_seroutchar_w   proc    near                                    ;
                push    dx                                      ;
                push    ax                                      ;
                mov     dx,cs:_ComPortAddr                      ; port addr present?
                or      dx,dx                                   ;
                jz      @@serout16_exit                         ;
                add     dx,COM_LSR                              ; status port
@@serout16_wait:
                in      al,dx                                   ; check status
                test    al,020h                                 ;
                jz      @@serout16_wait                         ; wait
                mov     dx,cs:_ComPortAddr                      ;
                mov     al,[esp+6]                              ; character from stack
                out     dx,al                                   ;

                cmp     al,13                                   ; skip \r
                jz      @@serout16_exit                         ;
                push    di                                      ;
ifdef INITDEBUG
                smsw    di                                      ; it can be called from
                test    di,1                                    ; 16-bit PM with INITDEBUG
                jnz     @@serout16_logskip                      ;
endif
                mov     di,cs:_logrmpos                         ;
                cmp     di,LOGBUF_SIZE-5-4                      ; rm buffer is full?
                jnc     @@serout16_logskip                      ;
                mov     dx,cs:_logbufseg                        ; is it inited at all?
                or      dx,dx                                   ;
                jz      @@serout16_logskip                      ;
                push    es                                      ;
                mov     es,dx                                   ;
                cld                                             ;
                or      di,di                                   ; 1st line in buffer?
                jz      @@serout16_firstline                    ;
                cmp     byte ptr es:[di-1],10                   ; last char is '\n'?
                jnz     @@serout16_logadd                       ;
                inc     di                                      ; skip 0
@@serout16_firstline:
                xchg    ah,al                                   ;
                mov     al,32h                                  ; flags + level
                stosb                                           ;
                xor     al,al                                   ; save zero time
                stosb                                           ; (we have troubles
                stosb                                           ; with current time
                stosb                                           ; on EFI host only)
                stosb                                           ;
                xchg    ah,al                                   ;
@@serout16_logadd:
                stosb                                           ;
                mov     byte ptr es:[di],0                      ; end of string
                mov     cs:_logrmpos,di                         ;
                pop     es                                      ;
@@serout16_logskip:
                pop     di                                      ;
@@serout16_exit:
ifdef INITDEBUG                                                 ;
                smsw    dx                                      ; additional output
                and     dx,1                                    ; to screen while 16bit
                xchg    dx,bx                                   ; init active
                shl     bx,1                                    ;
                mov     bx, cs:vio_out_proc[bx]                 ;
                xchg    dx,bx                                   ;
                call    dx                                      ;
endif
                pop     ax                                      ;
                pop     dx                                      ;
                ret     2                                       ;
_seroutchar_w   endp

ifdef INITDEBUG                                                 ;
printchar_pm    proc    near                                    ;
                ret                                             ;
printchar_pm    endp                                            ;

                public  printchar_rm
printchar_rm    proc    near
                assume  ds:nothing, ss:nothing

                SaveReg <ds,es>                                 ; preserve registers
                pusha                                           ;
                mov     bx, 0B800h                              ; text memory
                mov     ds, bx                                  ;
                mov     bx, 40h                                 ; bios data 40h
                mov     es, bx                                  ;

                mov     cx, es:[50h]                            ; cursor pos
                xor     bx, bx                                  ;
                cmp     al, 0Ah                                 ; EOL?
                je      @@eol                                   ;
                cmp     al, 0Dh                                 ; CR?
                jnz     @@nocr                                  ;
                xor     cl, cl                                  ;
                jmp     @@savepos                               ;
@@nocr:
                mov     bl, ch                                  ; offset
                imul    bx, 160                                 ;
                xor     ch, ch                                  ;
                shl     cx, 1                                   ;
                add     bx, cx                                  ; printing
                mov     ah, 0Ch                                 ; color
                mov     [bx], ax                                ;
                mov     cx, es:[50h]                            ; update cursor pos
                inc     cl                                      ; ch - row
                cmp     cl, 80                                  ;
                jc      @@savepos                               ;
@@eol:
                xor     cl, cl                                  ; new line
                movzx   bx, byte ptr es:[84h]                   ; number of lines
                cmp     ch, bl                                  ;
                jnz     @@noscroll                              ;
                mov     es:[50h], cx                            ; save cursor pos
                push    ds                                      ;
                pop     es                                      ;
                mov     si, 160                                 ; scrolling ;)
                xor     di, di                                  ;
                imul    cx, bx, 80                              ; (lines-1) * 80
            rep movsw                                           ;
                mov     cl, 80h                                 ;
                mov     ax, 0720h                               ; cleaning last line
            rep stosw                                           ;
                jmp     @@exit                                  ;
@@noscroll:
                inc     ch                                      ;  ப
@@savepos:
                mov     es:[50h],cx                             ; ࠭塞  
@@exit:
                popa                                            ;
                RestReg <es,ds>                                 ;
                ret                                             ;
printchar_rm    endp
endif

;
; get dgroup segment/selector (dual mode rm/pm proc)
;----------------------------------------------------------------
; OUT : AX - value
get_dgroup      proc    near
                smsw    ax                                      ;
                test    al,1                                    ;
                jz      @@getds_rm                              ;
                mov     ax,SELDATA                              ;
                ret                                             ;
@@getds_rm:
                mov     ax,cs                                   ;
                ret                                             ;
get_dgroup      endp

;
; save dword into storage (dual mode rm/pm proc)
;----------------------------------------------------------------
; IN : EAX - dword, SI - name, save all except flags
                public  sto_save_w
sto_save_w      proc    near
                pushad                                          ;
                SaveReg <ds,es>                                 ;
                push    eax                                     ; save value
                call    get_dgroup                              ; ds=es=dgroup
                mov     ds,ax                                   ;
                mov     es,ax                                   ;
                mov     bx,offset _storage_w                    ;
                xor     bp,bp                                   ; empty entry
@@svs_loop:
                lea     di,[bx+9]                               ;
                cmp     byte ptr [di],0                         ; name empty?
                jz      @@svs_empty                             ;
                push    si                                      ;
                mov     cx,11                                   ;
           repe cmpsb                                           ;
                pop     si                                      ;
                jnz     @@svs_nextloop                          ;
                jmp     @@svs_ready                             ;
@@svs_empty:
                mov     bp,bx                                   ; remember it
@@svs_nextloop:
                add     bx,STOINIT_ESIZE                        ;
                cmp     bx,offset _storage_w_end                ;
                jnz     @@svs_loop                              ; next entry
                mov     bx,bp                                   ; try to get empty
@@svs_ready:
                pop     eax                                     ;
                or      bx,bx                                   ; entry founded?
                jz      @@svs_failed                            ;
                mov     di,bx                                   ; store data &
                stosd                                           ; name
                mov     al,4                                    ;
                stosb                                           ; lo size byte
                xor     eax,eax                                 ;
                stosd                                           ; hi size + flag
                mov     cx,11                                   ;
            rep movsb                                           ;
@@svs_failed:
                RestReg <es,ds>                                 ;
                popad                                           ;
                ret                                             ;
sto_save_w      endp

;
; APIC timer RM vector ;)
;----------------------------------------------------------------
; install it actually, because there is no way to disable interrupt at 100%.
; Accepted interrupt can wait in IRR while we`re switching to RM and masking
; do nothing with it. Next it will crash VBox where high RM vectors are zero
; and stops timer on common BIOS with single iret without EOI.
;
                assume  ds:nothing, es:nothing, ss:nothing      ;
rm_timer        proc    near                                    ;
                push    eax                                     ;
                cli                                             ;
                mov     eax,cs:syslapic_p                       ;
                or      eax,eax                                 ;
                jz      @@rmt_irq_noapic                        ;
                pushad                                          ;
; a crazy thing, actually - enabling A20 in the interrupt handler :)
; but there is only one bugaboo, who can disable it - IBM PXE loader,
; which calls int 15h functions for memory cache i/o
                call    enablea20                               ;
                popad                                           ;
                push    fs                                      ;
                push    dx                                      ;
                push    ebx                                     ;
                push    ecx                                     ;
                push    edi                                     ;
                movzx   ebx,cs:_apic_tmr_vnum                   ;
                mov     ecx,ebx                                 ;
                and     cl,1Fh                                  ; check ISR bit
                shr     ebx,1                                   ; before sending
                and     bl,0F0h                                 ;
                mov     edi,eax                                 ;

                xor     eax,eax                                 ;
                or      ax,word ptr cs:mini_gdt_ptr+4           ; prepare GDT address
                jnz     @@rmt_gdtready                          ;
                mov     ax,cs                                   ; we`re always above
                shl     eax,4                                   ; 1000h, so use 3rd
                add     dword ptr cs:mini_gdt_ptr+2,eax         ; word as a flag
@@rmt_gdtready:
                lgdt    fword ptr cs:mini_gdt_ptr               ; set PM
                mov     eax,cr0                                 ;
                or      al,CPU_CR0_PE                           ;
                and     eax,not (CPU_CR0_PG or CPU_CR0_AM)      ;
                mov     cr0,eax                                 ;
                jmp     $+2                                     ;

                mov     dx,8                                    ; loads FS
                mov     fs,dx                                   ;

                bt      dword ptr fs:[edi+APIC_ISR_TAB*4+ebx],ecx ; EOI
                setc    cl                                      ; & statistics
                jnc     @@rmt_irq_notours                       ;
                xor     ebx,ebx                                 ;
                mov     fs:[edi+APIC_EOI*4],ebx                 ;
@@rmt_irq_notours:
                and     al,not CPU_CR0_PE                       ; exit to RM
                mov     cr0,eax                                 ;
                jmp     $+2                                     ;

                xor     ch,ch
                add     cs:apic_tmr_reoi,cx                     ; eoi counter
                inc     cs:apic_tmr_rcnt                        ; total counter
                pop     edi                                     ;
                pop     ecx                                     ;
                pop     ebx                                     ;
                pop     dx                                      ;
                pop     fs                                      ;
@@rmt_irq_noapic:
                pop     eax                                     ;
                iret                                            ;
rm_timer        endp                                            ;

rm_spurious     proc   near                                     ;
                iret                                            ;
rm_spurious     endp                                            ;

                public int10h_stub                              ;
int10h_stub     proc   near                                     ;
                iret                                            ;
int10h_stub     endp                                            ;

                public int16h_stub                              ;
int16h_stub     proc   near                                     ;
                cmp    ah,1                                     ;
                jz     @@i16s_ret                               ;
                cmp    ah,11h                                   ;
                jz     @@i16s_ret                               ;
                jmp    dword ptr cs:org_int16h                  ;
@@i16s_ret:
                push   bp                                       ; set ZF flag: no
                mov    bp,sp                                    ; keystrokes available
                or     word ptr [bp+6],CPU_EFLAGS_ZF            ;
                pop    bp                                       ;
                iret                                            ;
int16h_stub     endp                                            ;

TEXT16          ends
                end
