//
// QSINIT "boot menu" module
// internal header
//
#ifndef QSINIT_MENUOPTS
#define QSINIT_MENUOPTS

#include "qstypes.h"
#include "qcl/qsinif.h"

#define RCLINE_LEN    2048     // cmd.line buffer in stack

#ifdef __cplusplus
extern "C" {
#endif

/** merge options from menu, config line and common section of os2ldr.ini.

    @param line [in,out]  comma separated menu options, merged options on exit
    @param args           comma separated kernel config line options
    @param ini            qsinit.ini file
    @return -1 if RESTART selected, 1 on success  */
int mergeopts(char *line, u32t linelen, char *args, qs_inifile ini);

extern qs_inifile    m_ini,    // menu ini file
                    ld_ini;    // ldr ini file

#ifdef __cplusplus
}
#endif
#endif // QSINIT_MENUOPTS
