                .486p
                include inc/vgadef.inc
                include inc/biosdata.inc

                extrn   _page0_fptr:dword                       ;

_TEXT           segment para public USE32 'CODE'

; --------------------------------------------------------------------
; VGA helpers ...
                SEQCRTGRF_READ
                SEQCRTGRF_WRITE
crt_write_w     label   near                                    ;
                mov     al,dl                                   ;
                push    eax                                     ;
                mov     al,dh                                   ;
                call    crt_write                               ;
                pop     eax                                     ;
                inc     ah                                      ;
                call    crt_write                               ;
                ret                                             ;
; --------------------------------------------------------------------
; set 8-dot mode while in VGA text mode
                public  _vga_set8dots                           ;
_vga_set8dots   proc    public                                  ;
; sequencer: synchronous reset + set clocking mode
                mov     ax,0001h                                ;
                call    seq_write                               ; R00 - set sync reset

                inc     ah                                      ; R01 - clocking mode
                out     dx,al                                   ;
                inc     dx                                      ; sequencer data
                in      al,dx                                   ;
                or      al,1                                    ; set bit 0: 8 dots/char
                out     dx,al                                   ;
; misc output: select 25.1750 MHz dot clock
                mov     dl,0CCh                                 ; VGA_MISC_READ
                in      al,dx                                   ;
                and     al,0FBh                                 ; selects 25MHz clock
                mov     dl,0C2h                                 ;
                out     dx,al                                   ; VGA_MISC_WRITE
; clear synchronous reset in the sequencer
                mov     ax,0003h                                ;
                call    seq_write                               ; R00 - clear sync reset
; attribute controller: set pixel panning
                mov     dl,0DAh                                 ; VGA_ATR_RESET
                in      al,dx                                   ; resets port 3C0 flip-flop
                mov     dl,0C0h                                 ; VGA_ATR_ADDR
                mov     al,33h                                  ; idx: 13h - pixel panning
                out     dx,al                                   ; + 20h - keep video enabled!
                xor     al,al                                   ; data: 0 = no panning
                out     dx,al                                   ; mode w/line graphics OFF)
                mov     al,30h                                  ; idx: 10h - mode control 
                out     dx,al                                   ; + 20h - keep video enabled!
                in      al,dx                                   ; read current value
                and     al,0FBh                                 ; data: bit 2 = line graphics OFF
                out     dx,al                                   ;
                ret
_vga_set8dots   endp                                            ;

; --------------------------------------------------------------------
; set 9-dot mode while in VGA text mode
                public  _vga_set9dots                           ;
_vga_set9dots   proc    public                                  ;
; sequencer: synchronous reset + set clocking mode
                mov     ax,0001h                                ;
                call    seq_write                               ; R00 - set sync reset
                
                inc     ah                                      ; R01 - clocking mode
                out     dx,al                                   ;
                inc     dx                                      ; sequencer data
                in      al,dx                                   ;
                and     al,0FEh                                 ; clear bit 0: 9 dots/char
                out     dx,al   
; misc output: select 28.3220MHz dot clock
                mov     dl,0CCh                                 ; VGA_MISC_READ
                in      al,dx                                   ;
                or      al,4                                    ; selects 28MHz clock
                mov     dl,0C2h                                 ;
                out     dx,al                                   ; VGA_MISC_WRITE
; clear synchronous reset in the sequencer
                mov     ax,0003h                                ;
                call    seq_write                               ; R00 - clear sync reset
; attribute controller: set pixel panning
                mov     dl,0DAh                                 ; VGA_ATR_RESET
                in      al,dx                                   ; resets port 3C0 flip-flop
                mov     dl,0C0h                                 ; VGA_ATR_ADDR
                mov     al,33h                                  ; idx: 13h - pixel panning
                out     dx,al                                   ; + 20h - keep video enabled!
                mov     al,8                                    ; data: 8 = no panning (in 9-dot
                out     dx,al                                   ; mode w/line graphics ON)
                mov     al,30h                                  ; idx: 10h - mode control 
                out     dx,al                                   ; + 20h - keep video enabled!
                in      al,dx                                   ; read current value
                or      al,4                                    ; data: bit 2 = line graphics ON
                out     dx,al                                   ;
                ret                                             ;
_vga_set9dots   endp                                            ;

; ===============================================================
; load text mode font
; ===============================================================

; in: dx  - port
;     esi - seq addr
packet_write    proc    near                                    ;
@@pktw_loop:
                lodsw                                           ;
                cmp     ax,-1                                   ;
                jz      @@pktw_exit                             ;
                out     dx,ax                                   ;
                jmp     @@pktw_loop                             ;
@@pktw_exit:
                ret                                             ;
packet_write    endp                                            ;

fnt_open_seq    dw      0100h, 402h,  704h, 300h, 0FFFFh        ; seq
                dw      0204h,   5h,  406h, 0FFFFh              ; grdc
fnt_close_seq   dw      0100h, 302h,  304h, 300h, 0FFFFh        ; seq
                dw      0E06h,    4, 1005h, 0FFFFh              ; grdc

; ---------------------------------------------------------------
; void vga_loadfont(u16t fntseg, u32t fonty, u32t blockno);
; load font
;
                public  _vga_loadfont                           ;
_vga_loadfont   proc    near                                    ;
                push    esi                                     ;
                mov     esi,[esp+8]                             ; font segment
                mov     dh,[esp+12]                             ; font height
                mov     dl,[esp+16]                             ; block to load in map 2 (bios call bl reg)
                push    edi                                     ;
                xor     edi,edi                                 ;
                cld                                             ;

                push    fs                                      ;
                lfs     ecx,_page0_fptr                         ; update
                mov     fs:[ecx+268],di                         ; 43h vector
                mov     fs:[ecx+270],si                         ;
                pop     fs                                      ;
                shl     esi,4                                   ; seg->flat

                push    esi                                     ; open memory
                push    edx                                     ;
                mov     esi,offset fnt_open_seq                 ;
                mov     dx,VGA_SEQ_ADDR                         ;
                call    packet_write                            ;
                mov     dx,VGA_GRC_ADDR                         ;
                call    packet_write                            ;
                pop     edx                                     ;
                pop     esi                                     ;

                mov     al,dl                                   ; apply block #
                and     eax,3                                   ;
                shl     eax,14                                  ;
                add     edi,eax                                 ;
                mov     al,dl                                   ;
                and     eax,4                                   ;
                shl     eax,11                                  ;
                lea     edi,[0A0000h+eax+edi]                   ;

                xor     al,al                                   ; # of chars
                xor     ecx,ecx                                 ;
@@lf_loop:
                mov     cl,dh                                   ; height
                push    edi                                     ;
            rep movsb                                           ;
                pop     edi                                     ;
                add     edi,32                                  ;
                dec     al                                      ;
                jnz     @@lf_loop                               ;

                mov     esi,offset fnt_close_seq                ;
                mov     dx,VGA_SEQ_ADDR                         ;
                call    packet_write                            ;
                mov     dx,VGA_GRC_ADDR                         ;
                call    packet_write                            ;

                pop     edi                                     ;
                pop     esi                                     ;
                ret     12                                      ;
_vga_loadfont   endp                                            ;

; get active vertical display end (# of scan lines)
; ---------------------------------------------------------------
; ret: eax - value, edx lost
get_vde         proc    near                                    ;
                mov     ah,12h                                  ; low 8 bit
                call    crt_read                                ;
                push    ecx                                     ;
                movzx   ecx,al                                  ;
                mov     ah,7                                    ; bit 9 & 10
                call    crt_read                                ;
                mov     ah,al                                   ;
                shr     ah,1                                    ;
                and     ah,1                                    ;
                shr     al,5                                    ;
                and     al,2                                    ;
                or      ah,al                                   ;
                xor     edx,edx                                 ;
                mov     dh,ah                                   ;
                lea     eax,[ecx+edx+1]                         ;
                pop     ecx                                     ;
                ret                                             ;
get_vde         endp                                            ;

; ---------------------------------------------------------------
; void _std vga_setlines(u16t fonty);
; set scan lines
;
                public  _vga_setlines                           ;
_vga_setlines   proc    near                                    ;
                mov     cl,[esp+4]                              ; font height
                push    ebx                                     ;
                push    edi                                     ;
                push    fs                                      ;
                mov     ah,9                                    ;
                call    crt_read                                ;
                movzx   ebx,cl                                  ;
                dec     cl                                      ;
                and     cl,1Fh                                  ;
                and     al,not 1Fh                              ;
                or      al,cl                                   ;
                call    crt_write                               ;

                lfs     edi,_page0_fptr                         ;
                add     edi,400h                                ;
                mov     fs:[edi].BDA_VCharLines,bx              ;

                call    get_vde                                 ; calc rows
                xor     edx,edx                                 ;
                div     ebx                                     ;
                mov     dl,al                                   ;
                dec     dl                                      ;
                mov     fs:[edi].BDA_VRows,dl                   ;
                mul     fs:[edi].BDA_VCols                      ; calc page size
                shl     ax,1                                    ;
                add     ax,7FFh                                 ; round to 2k
                and     ax,not 7FFh                             ;
                mov     fs:[edi].BDA_VPageSize,ax               ;

                mov     dx,607h                                 ;
                cmp     bl,8                                    ;
                jz      @@set_sl_shape                          ;
                mov     dh,bl                                   ;
                mov     dl,bl                                   ;
                sub     dh,3                                    ;
                sub     dl,2                                    ;
@@set_sl_shape:
                mov     ah,10                                   ; cursor shape regs
                call    crt_write_w                             ;

                pop     fs                                      ;
                pop     edi                                     ;
                pop     ebx                                     ;
                ret     4                                       ;
_vga_setlines   endp                                            ;

_TEXT           ends
                end
