//
// QSINIT API
// wchar c library functions
//
#ifndef QSINIT_WCHAR
#define QSINIT_WCHAR

#ifdef __cplusplus
extern "C" {
#endif
#include "qstypes.h"

/* Watcom C++ 1.9 (only C++, not C) have embedded wchar_t check and shows
   error on typedef, so use define here */
#ifdef wchar_t
#undef wchar_t
#endif
#define wchar_t c16t
#define wint_t  c16t

u32t     _std    wcslen   (const wchar_t *str);
wchar_t* _std    wcscpy   (wchar_t *dst, const wchar_t *src);
wchar_t* _std    wcsncpy  (wchar_t *dst, const wchar_t *src, u32t n);
int      _std    wcscmp   (const wchar_t *s1, const wchar_t *s2);
int      _std    wcsncmp  (const wchar_t *s1, const wchar_t *s2, u32t n);
int      _std    _wcsicmp (const wchar_t *s1, const wchar_t *s2); 
int      _std    _wcsnicmp(const wchar_t *s1, const wchar_t *s2, u32t n); 

wchar_t* _std    wcscat   (wchar_t *dst, const wchar_t *src);
wchar_t* _std    wcsncat  (wchar_t *dst, const wchar_t *src, u32t n);
wchar_t* _std    _wcsdup  (const wchar_t *src);

wchar_t* _std    wcschr   (const wchar_t *str, int c);
wchar_t* _std    wcsrchr  (const wchar_t *str, wint_t c);
wchar_t* _std    wcsstr   (const wchar_t *str, const wchar_t *substr);


wchar_t* _std    _wcsupr  (wchar_t *src);
wchar_t* _std    _wcslwr  (wchar_t *src);
wchar_t  _std    towlower (wchar_t chr);
wchar_t  _std    towupper (wchar_t chr);

wchar_t* _std    wcspbrk  (const wchar_t *str, const wchar_t *charset);

int      __cdecl wprintf  (const wchar_t *, ...);
int      __cdecl swprintf (wchar_t *, u32t, const wchar_t *, ...);
#ifdef QSINIT_STDLIB
int      __cdecl fwprintf (FILE *, const wchar_t *, ...);
#endif
#ifdef QSINIT_STDARG
int      _std    vwprintf (const wchar_t *, va_list);
int      _std    _vsnwprintf(wchar_t *, u32t, const wchar_t *, va_list);
/// utf version of vsprintf_dyn()
wchar_t* _std    vwsprintf_dyn(const wchar_t *fmt, va_list arg);
#endif
#if defined(QSINIT_STDLIB) && defined(QSINIT_STDARG)
int      _std    vfwprintf(FILE *, const wchar_t *, va_list);
#endif
/// utf version of _matchpattern()
int      _std    _matchpatternw(const wchar_t *pattern, const wchar_t *str);
/// utf version of _replacepattern()
int      _std    _replacepatternw(const wchar_t *frompattern,
                           const wchar_t *topattern, const wchar_t *from,
                           wchar_t *to);
/// utf version of strcat_dyn()
wchar_t* _std    wcscat_dyn(wchar_t *dst, const wchar_t *src);
/// utf version of strdup_dyn()
wchar_t* _std    wcsdup_dyn(const wchar_t *src, u32t n);
/// utf version of sprintf_dyn()
wchar_t* __cdecl swprintf_dyn(const wchar_t *format, ...);

#ifdef __cplusplus
}
#endif
#endif // QSINIT_WCHAR
