//
// QSINIT "help" module
// internal functions
//

#ifndef QSINIT_HELPLOCAL
#define QSINIT_HELPLOCAL

#include "qstypes.h"
#include "qserr.h"
#ifdef __QSINIT__
#include "qshelp.h"
#include "qslog.h"
#include "qsint.h"
#else
#include "../hc/qshelp.h"
#define log_printf(...)
#define malloc_local malloc
#define malloc_th    malloc
#endif

#ifdef __cplusplus
#include "classes.hpp"
#include "minmax.h"

#define rINT_HEX  1
#define rINT_PER  2  ///< percent value allowed
#define rINT_UNS  4  ///< unsigned only

qserr get_int(const char *&src, u32t width, int &res, int mode);
#endif

#ifdef __QSINIT__
#ifdef __cplusplus
extern "C" {
#endif
void  help_lock(void);
void  help_unlock(void);
void* malloc_local(u32t size);
#endif
#ifdef __cplusplus
#ifdef __QSINIT__
}
class HelpCritSec {
public:
   HelpCritSec() { help_lock(); }
   ~HelpCritSec() { help_unlock(); }
};

class SysLock {
public:
   SysLock() { mt_syslock(); }
   ~SysLock() { mt_sysunlock(); }
};

qserr help_unpack(const char *path, TStrings &text);

#else // PC build
class HelpCritSec {
public:
   HelpCritSec() {}
   ~HelpCritSec() {}
};

class SysLock {
public:
   SysLock() {}
   ~SysLock() {}
};
#endif
#endif // __cplusplus

#endif // QSINIT_HELPLOCAL
