//
// QSINIT
// partition management dll
//
#include "stdlib.h"
#include "qsutil.h"
#include "qsmod.h"
#include "qssys.h"
#include "qsio.h"
#include "qstask.h"
#include "memmgr.h"
#include "qsshell.h"
#include "pscan.h"

const char  *selfname = MODNAME_DMGR;
//static qshandle  cmux = 0;
// free partition list data
void scan_free(void);
void set_hooks(void);
void remove_hooks(void);
void lvm_buildcrc(void);

static qs_mtlib mtlib  = 0;
u32t            mtmode = 0;

// use dynamic MTLIB calls to prevent dependency on its presence
qs_mtlib get_mtlib(void) {
   mt_swlock();
   // first time init
   if (!mtlib) mtlib = NEW_G(qs_mtlib);
   mt_swunlock();
   return mtlib;
}

// MT mode notification callback
static void _std on_mtmode(sys_eventinfo *info) {
   mtmode = 1;
}

extern unsigned __stdcall _wc_static_init();
extern unsigned __stdcall _wc_static_fini();

unsigned __cdecl LibMain( unsigned hmod, unsigned termination ) {
   if (!termination) {
      if (mod_query(selfname,MODQ_LOADED|MODQ_NOINCR)) {
         log_printf("%s already loaded!\n",selfname);
         return 0;
      }
      // init static variables & classes
      _wc_static_init();
      // catch MT mode
      if (!mt_active()) sys_notifyevent(SECB_MTMODE|SECB_GLOBAL, on_mtmode);
         else on_mtmode(0);
      cmd_shelladd("GPT"   ,shl_gpt);
      cmd_shelladd("LVM"   ,shl_lvm);
      cmd_shelladd("DMGR"  ,shl_dmgr);
      cmd_shelladd("MOUNT" ,shl_mount);
      cmd_shelladd("UMOUNT",shl_umount);
      cmd_shelladd("FORMAT",shl_format);
      log_printf("%s is loaded!\n",selfname);
      lvm_buildcrc();
      set_hooks();
      // allocate disk array
      scan_init();
   } else {
      if (!mtmode) sys_notifyevent(0, on_mtmode);
      cmd_shellrmv("FORMAT",shl_format);
      cmd_shellrmv("UMOUNT",shl_umount);
      cmd_shellrmv("MOUNT" ,shl_mount);
      cmd_shellrmv("DMGR"  ,shl_dmgr);
      cmd_shellrmv("LVM"   ,shl_lvm);
      cmd_shellrmv("GPT"   ,shl_gpt);
      remove_hooks();
      scan_free();
      cache_free();
      gptcfg_free();
      if (mtlib) DELETE(mtlib);
      log_printf("%s unloaded!\n",selfname);
      // fini static variables & classes
      _wc_static_fini();
   }
   return 1;
}
