#include "qs_rt.h"

str_list* str_getlist(TStringVector &lst) {
   l len=sizeof(str_list)+lst.Count()*sizeof(char*), dlen=0, ii;

   for (ii=0;ii<=lst.Max();ii++) dlen+=lst[ii].trim().length()+1;
   str_list *rc=(str_list*)malloc(len+dlen);
   if (!rc) return 0;
   rc->count=lst.Count();
   char *pos=(char*)rc+len;
   for (ii=0;ii<=lst.Max();ii++) {
      /* trim spaces around '='. 
         pure "C" code in bootos2/console.dll assume this */
      int vpos=lst[ii][0]!=';'?lst[ii].cpos('='):-1;
      if (vpos>1) lst[ii]=spstr(lst[ii],0,vpos).trim()+'='+
         spstr(lst[ii],vpos+1,lst[ii].length()).trim();
      // copying into buffer
      rc->item[ii]=pos;
      strcpy(pos,lst[ii]());
      pos+=lst[ii].length()+1;
   }
   return rc;
}

str_list* str_getlistpure(TStringVector &lst) {
   l len=sizeof(str_list)+lst.Count()*sizeof(char*), dlen=0, ii;

   for (ii=0;ii<=lst.Max();ii++) dlen+=lst[ii].length()+1;
   str_list *rc=(str_list*)malloc(len+dlen);
   if (!rc) return 0;
   rc->count=lst.Count();
   char *pos=(char*)rc+len;
   for (ii=0;ii<=lst.Max();ii++) {
      rc->item[ii]=pos;
      strcpy(pos,lst[ii]());
      pos+=lst[ii].length()+1;
   }
   return rc;
}

char* str_unroll(const TStringVector &lst, u32t start, u32t count, void *dst,
                 u32t &dstlen, char **ptrlist)
{
   if (!lst.Count() || start>=lst.Count()) return 0;
   if (!count) count = lst.Count();
   count += start;
   if (count>lst.Count()) count = lst.Count();
   // total length
   u32t len=0, ii;
   for (ii=start; ii<count; ii++) len+=lst.Value()[ii].length() + 1;
   if (!len) { dstlen = 0; return 0; }
   // return needed value if error
   int lowmem = dst && dstlen<len;
   dstlen = len;
   if (lowmem) return 0;
   if (!dst) dst = malloc(len);

   if (dst) {
      char *sptr = (char*)dst;
      for (ii=start; ii<count; ii++) {
         memcpy(sptr, lst.Value()[ii](), lst.Value()[ii].length()+1);
         if (ptrlist) ptrlist[ii-start] = sptr;
         sptr += lst.Value()[ii].length() + 1;
      }
   }
   return (char*)dst;
}
