//
// QSINIT "sysview" module
// help support header
//
#ifndef QS_SYSVIEW_HELPWIN
#define QS_SYSVIEW_HELPWIN

#include "diskedit.h"
#ifdef __QSINIT__
#include "qshelp.h"
#else
#include "helploc.h"
#endif

#define HELPFILE_SYSVIEW    0
#define HELPFILE_QSSYS      1

#define HELPFILE_GOBACK    -1 // only in TAppQHWindow constructor!

// help viewer control for QS help
class TQHViewer : public TScroller {
   int      hfIndex,
            topicid,
           selected;
   qsh_topic *topic;
   qserr   ldrawerr;
   TCollection *lth;

   void updateTopic();
   void checkLink();
   int  findLink(int);
   void pushHistory(int, int, int, int);
   void    makeSelectVisible(int);
public:
   TQHViewer(const TRect &, TScrollBar *, int, const char *, Boolean);
   ~TQHViewer();

   virtual void changeBounds(const TRect &);
   virtual void draw();
   virtual TPalette &getPalette() const;
   virtual void handleEvent(TEvent &);
   Boolean switchToTopic(int, const char *);
   Boolean gotoToTopic(int, int, int, const char *, int, Boolean);
   Boolean goBack();
   int     hfNum() { return hfIndex; }
};

class TAppQHWindow: public TAppWindow {
   TQHViewer   *hwc;
public:
   TAppQHWindow(int, const char *);
   void goTopic(int, const char *);

   virtual void handleEvent(TEvent &);
   virtual const char *getTitle(short);
   virtual void sizeLimits(TPoint &min, TPoint &max);
   virtual TPalette &getPalette() const;
};

class TQHWindow : public TWindow {
   TQHViewer   *hwc;
public:
   TQHWindow(int, const char *);

   virtual void sizeLimits(TPoint &min, TPoint &max);
   virtual TPalette &getPalette() const;
};

// file should loaded before first use
qserr TQH_LoadHelp(int index);

#endif // QS_SYSVIEW_HELPWIN
