;
; QSINIT
; PAE RAM disk : hiding the disk memory
;
                include inc/qstypes.inc
                include inc/cpudef.inc
                include inc/rmeinfo.inc

RMFILTER GROUP  BIOSFLT_CODE

BIOSFLT_CODE    segment byte public USE16 'CODE16'
                assume  cs:BIOSFLT_CODE,ds:nothing,es:nothing,ss:nothing

                public  _biosfltinfo                            ;
_biosfltinfo:   db      48 dup (0)                              ;
                dd      MEMLIST_SIGN                            ;
                dw      offset seglen                           ;
                dw      offset resbiosvec                       ;
                dw      headerend - _biosfltinfo                ; header size
state           dw      1                                       ; state
tablen          dw      0                                       ; tablen
                dw      2                                       ; inttab rev (match check)
                dd      0                                       ;
resbiosvec:     db      12h                                     ;
                dw      offset int12h                           ;
                dd      0                                       ;
                db      15h                                     ;
                dw      offset int15h                           ;
orgint15h       dd      0                                       ;
                db      0FFh                                    ;
headerend:
; table above is actually struc I15hListInfo
if size I15hListInfo NE (resbiosvec - _biosfltinfo)             ; check size
                .err                                            ;
endif                                                           ;

int12h          proc    near                                    ;
                mov     ax,cs                                   ;
                shr     ax,6                                    ;
                iret                                            ;
int12h          endp                                            ;

int15h          proc    near                                    ;
                test    cs:state,1                              ; disabled?
                jz      @@i15_org                               ;
                cmp     ax, 0E820h                              ;
                jnz     @@i15_org                               ;
                cmp     edx,534D4150h                           ; 'SMAP'
                jnz     @@i15_org                               ;
                push    si                                      ;
                cmp     bx,cs:tablen                            ;
                jc      @@i15h_getmem                           ;
                mov     ah,86h                                  ;
                stc                                             ;
                jmp     @@i15h_exit                             ;
@@i15h_getmem:
                mov     si,bx                                   ;
                imul    si,20                                   ;
                add     si,offset seglen                        ;

                mov     ecx,20                                  ;
                push    di                                      ;
                push    cx                                      ;
                cld                                             ;
            rep movs    byte ptr es:[di],byte ptr cs:[si]       ;
                pop     cx                                      ;
                pop     di                                      ;

                mov     eax,edx                                 ;
                inc     bx                                      ;
                cmp     bx,cs:tablen                            ;
                jc      @@i15h_done                             ;
                xor     ebx,ebx                                 ;
@@i15h_done:
                clc                                             ;
@@i15h_exit:
                mov     si,6                                    ; si, far call
                call    set_CF                                  ;
                pop     si                                      ;
                iret                                            ;
@@i15_org:
                jmp     dword ptr cs:orgint15h                  ;
int15h          endp                                            ;

; ---------------------------------------------------------------
; set CF in caller`s stack
; in : si - bytes up to flags in stack (before the function call)
; out: bit updated, si changed
set_CF          label   near                                    ;
                pushf                                           ;
                push    ax                                      ;
                mov     al,CPU_EFLAGS_CF                        ;
@@setCF_main:
                lahf                                            ; flags -> ah
                add     si,sp                                   ;
                add     si,6                                    ; +2 ax +2 flags +2 call
                test    ah,al                                   ;
                jnz     @@setCF_set                             ;
                not     al                                      ;
                and     ss:[si],al                              ; clear flag
                pop     ax                                      ;
                popf                                            ;
                ret                                             ;
@@setCF_set:
                or      ss:[si],al                              ; set flag
                pop     ax                                      ;
                popf                                            ;
                ret                                             ;
seglen:

BIOSFLT_CODE    ends
                end
