;
; QSINIT EFI loader
; 64-bit runtime functions
;
                .code

;----------------------------------------------------------------
;s32t  bsf64(u64t value);
bsf64           proc    public
                bsf     rax,rcx                                 ;
                jnz     @@bsfq_done                             ;
                or      eax,-1                                  ;
@@bsfq_done:
                ret                                             ;
bsf64           endp                                            ;
;----------------------------------------------------------------
;s32t  bsr64(u64t value);
bsr64           proc    public
                bsr     rax,rcx                                 ;
                jnz     @@bsrq_done                             ;
                or      eax,-1                                  ;
@@bsrq_done:
                ret                                             ;
bsr64           endp                                            ;
;----------------------------------------------------------------
;u32t _bittestq (u64t src, u32t bit);
_bittestq       proc    public                                  ;
                xor     eax,eax                                 ;
                bt      rcx,rdx                                 ;
                setc    al                                      ;
                ret                                             ;
_bittestq       endp                                            ;
;----------------------------------------------------------------
;u32t _bittestd (u32t src, u32t bit);
_bittestd       proc    public                                  ;
                xor     eax,eax                                 ;
                bt      ecx,edx                                 ;
                setc    al                                      ;
                ret                                             ;
_bittestd       endp                                            ;
;----------------------------------------------------------------
;u32t _bitsetq  (u64t *dst, u32t bit);
_bitsetq        proc    public                                  ;
                and     rdx,-1                                  ;
                xor     eax,eax                                 ;
                bts     [rcx],rdx                               ;
                setc    al                                      ;
                ret                                             ;
_bitsetq        endp                                            ;
;----------------------------------------------------------------
;u32t _bitset   (u32t *dst, u32t bit);
_bitset         proc    public                                  ;
                xor     eax,eax                                 ;
                bts     dword ptr [rcx],edx                     ;
                setc    al                                      ;
                ret                                             ;
_bitset         endp                                            ;
;----------------------------------------------------------------
;u32t _bitresetq(u64t *dst, u32t bit);
_bitresetq      proc    public                                  ;
                and     rdx,-1                                  ;
                xor     eax,eax                                 ;
                btr     [rcx],rdx                               ;
                setc    al                                      ;
                ret                                             ;
_bitresetq      endp                                            ;
;----------------------------------------------------------------
;u32t _bitreset (u32t *dst, u32t bit);
_bitreset       proc    public                                  ;
                xor     eax,eax                                 ;
                btr     dword ptr [rcx],edx                     ;
                setc    al                                      ;
                ret                                             ;
_bitreset       endp                                            ;
;----------------------------------------------------------------
;char* strcpy(char *dst, const char *src);
strcpy          proc    public
                push    rsi                                     ;
                push    rdi                                     ;
                mov     rsi,rdx                                 ;
                mov     rdi,rcx                                 ;
                cld                                             ;
@@scpy_cpy:
                lodsb                                           ;
                stosb                                           ;
                test    al,al                                   ;
                jnz     @@scpy_cpy                              ;
                pop     rdi                                     ;
                mov     rax,rcx                                 ;
                pop     rsi                                     ;
                ret                                             ;
strcpy          endp
;----------------------------------------------------------------
;wchar_t* wcscpy(wchar_t *dst, const wchar_t *src);
wcscpy          proc    public
                push    rsi                                     ;
                push    rdi                                     ;
                mov     rsi,rdx                                 ;
                mov     rdi,rcx                                 ;
                cld                                             ;
@@wscpy_cpy:
                lodsw                                           ;
                stosw                                           ;
                test    ax,ax                                   ;
                jnz     @@wscpy_cpy                             ;
                pop     rdi                                     ;
                mov     rax,rcx                                 ;
                pop     rsi                                     ;
                ret                                             ;
wcscpy          endp
;----------------------------------------------------------------
;u64t wcslen(const wchar_t *str);
wcslen          proc    public
                push    rdi                                     ;
                jrcxz   @@wcslen_null                           ;
                mov     rdi,rcx                                 ;
                cld                                             ;
                xor     rcx,rcx                                 ;
                dec     rcx                                     ;
                xor     ax,ax                                   ;
          repne scasw                                           ;
                not     rcx                                     ;
                dec     rcx                                     ;
@@wcslen_null:
                mov     rax,rcx                                 ;
                pop     rdi                                     ;
                ret                                             ;
wcslen          endp                                            ;
;----------------------------------------------------------------
;u64t strlen(const char *s);
strlen          proc    public
                push    rdi                                     ; avoid supplied
                jrcxz   @@strlen_null                           ; NULL (return 0)
                mov     rdi,rcx                                 ;
                cld                                             ;
                xor     rcx,rcx                                 ;
                dec     rcx                                     ;
                xor     al,al                                   ;
          repne scasb                                           ;
                not     rcx                                     ;
                dec     rcx                                     ;
@@strlen_null:
                mov     eax,ecx                                 ;
                pop     rdi                                     ;
                ret                                             ;
strlen          endp                                            ;
;----------------------------------------------------------------
;u8t* memchr(u8t*mem, u8t chr, u64t buflen);
memchr          proc    public
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@mch_exit                              ;
                mov     al,dl                                   ;
                cld                                             ;
          repne scasb                                           ;
                jnz     @@mch_exit                              ;
                lea     rcx,[rdi-1]                             ;
@@mch_exit:
                mov     rax,rcx                                 ;
                pop     rdi                                     ;
                ret                                             ;
memchr          endp                                            ;
;----------------------------------------------------------------
;u8t* memchrnb(u8t*mem, u8t chr, u64t buflen);
memchrnb        proc    public
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@mchn_exit                             ;
                mov     al,dl                                   ;
                cld                                             ;
           repe scasb                                           ;
                jz      @@mchn_exit                             ;
                lea     rcx,[rdi-1]                             ;
@@mchn_exit:
                mov     rax,rcx                                 ;
                pop     rdi                                     ;
                ret                                             ;
memchrnb        endp                                            ;
;----------------------------------------------------------------
;u16t* memchrw(u16t*mem, u16t chr, u64t buflen);
memchrw         proc    public
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@mchw_exit                             ;
                mov     ax,dx                                   ;
                cld                                             ;
          repne scasw                                           ;
                jnz     @@mchw_exit                             ;
                lea     rcx,[rdi-2]                             ;
@@mchw_exit:
                mov     rax,rcx                                 ;
                pop     rdi                                     ;
                ret                                             ;
memchrw         endp                                            ;
;----------------------------------------------------------------
;u16t* memchrnw(u16t*mem, u16t chr, u64t buflen);
memchrnw        proc    public
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@mchnw_exit                            ;
                mov     ax,dx                                   ;
                cld                                             ;
           repe scasw                                           ;
                jz      @@mchnw_exit                            ;
                lea     rcx,[rdi-2]                             ;
@@mchnw_exit:
                mov     rax,rcx                                 ;
                pop     rdi                                     ;
                ret                                             ;
memchrnw        endp                                            ;
;----------------------------------------------------------------
;u32t* memchrd(u32t*mem, u32t chr, u64t buflen);
memchrd         proc    public
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@mchd_exit                             ;
                mov     eax,edx                                 ;
                cld                                             ;
          repne scasd                                           ;
                jnz     @@mchd_exit                             ;
                lea     rcx,[rdi-4]                             ;
@@mchd_exit:
                mov     rax,rcx                                 ;
                pop     rdi                                     ;
                ret                                             ;
memchrd         endp                                            ;
;----------------------------------------------------------------
;u32t* memchrnd(u32t*mem, u32t chr, u64t buflen);
memchrnd        proc    public
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@mchnd_exit                            ;
                mov     eax,edx                                 ;
                cld                                             ;
           repe scasd                                           ;
                jz      @@mchnd_exit                            ;
                lea     rcx,[rdi-4]                             ;
@@mchnd_exit:
                mov     rax,rcx                                 ;
                pop     rdi                                     ;
                ret                                             ;
memchrnd        endp                                            ;
;----------------------------------------------------------------
;u64t* memchrq(u64t*mem, u64t chr, u64t buflen);
memchrq         proc    public
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@mchq_exit                             ;
                mov     rax,rdx                                 ;
                cld                                             ;
          repne scasq                                           ;
                jnz     @@mchq_exit                             ;
                lea     rcx,[rdi-8]                             ;
@@mchq_exit:
                mov     rax,rcx                                 ;
                pop     rdi                                     ;
                ret                                             ;
memchrq         endp                                            ;
;----------------------------------------------------------------
;u64t* memchrnq(u64t*mem, u64t chr, u64t buflen);
memchrnq        proc    public
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@mchnq_exit                            ;
                mov     rax,rdx                                 ;
                cld                                             ;
           repe scasq                                           ;
                jz      @@mchnq_exit                            ;
                lea     rcx,[rdi-8]                             ;
@@mchnq_exit:
                mov     rax,rcx                                 ;
                pop     rdi                                     ;
                ret                                             ;
memchrnq        endp                                            ;
;----------------------------------------------------------------
;void memset(void *dst, int c, u64t length);
memset          proc    public                                  ;
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@set0                                  ;
                mov     al,dl                                   ;
                mov     dl,cl                                   ;
                cld                                             ;
                shr     rcx,3                                   ;
                jz      @@setb                                  ;
                mov     ah,al                                   ;
                push    ax                                      ;
                push    ax                                      ;
                push    ax                                      ;
                push    ax                                      ;
                pop     rax                                     ;
            rep stosq                                           ;
@@setb:
                mov     cl,dl                                   ;
                and     cl,7                                    ;
                jz      @@set0                                  ;
            rep stosb                                           ;
@@set0:                                                         ;
                pop     rdi                                     ;
                ret                                             ;
memset          endp
;----------------------------------------------------------------
;void memsetw(u16t *dst, u16t value, u64t length);
memsetw         proc    public                                  ;
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@setw0                                 ;
                mov     ax,dx                                   ;
                cld                                             ;
            rep stosw                                           ;
@@setw0:
                pop     rdi                                     ;
                ret                                             ;
memsetw         endp

;----------------------------------------------------------------
;void memsetd(u32t *dst, u32t value, u64t length);
memsetd         proc    public                                  ;
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@setd0                                 ;
                mov     eax,edx                                 ;
                cld                                             ;
            rep stosd                                           ;
@@setd0:
                pop     rdi                                     ;
                ret                                             ;
memsetd         endp

;----------------------------------------------------------------
;void memsetq(u64t *dst, u64t value, u64t length);
memsetq         proc    public                                  ;
                push    rdi                                     ;
                mov     rdi,rcx                                 ;
                mov     rcx,r8                                  ;
                jrcxz   @@setq0                                 ;
                mov     rax,rdx                                 ;
                cld                                             ;
            rep stosq                                           ;
@@setq0:
                pop     rdi                                     ;
                ret                                             ;
memsetq         endp

                end
