;
; QSINIT EFI loader
; exception handlers
;

                include inc/seldesc.inc
                include inc/cpudef.inc

                extrn   Xcpt64Addr:fword                        ;
                extrn   Stack32  :fword                         ;
                extrn   XcptStack:qword                         ;
                extrn   SavedIDTv:qword                         ;

                .data

                public  trap_table
trap_table      dq      offset trap_0                           ; exception handler
                dq      offset trap_1                           ; table
                dq      0                                       ;
                dq      offset trap_3                           ;
                dq      offset trap_4                           ;
                dq      offset trap_5                           ;
                dq      offset trap_6                           ;
                dq      offset trap_7                           ;
                dq      offset trap_8                           ;
                dq      0                                       ;
                dq      offset trap_10                          ;
                dq      offset trap_11                          ;
                dq      offset trap_12                          ;
                dq      offset trap_13                          ;
                dq      offset trap_14                          ;
                dq      0                                       ;
                dq      offset trap_16                          ;
                dq      offset trap_17                          ;
                dq      offset trap_18                          ;
                dq      offset trap_19                          ;
                dq      -1                                      ;

                .code

IRP             x,<8,10,11,12,13,14,17>                         ; exceptions with
                public  trap_&x                                 ; error code
trap_&x:                                                        
                push    x                                       ;
                jmp     common_trap                             ;
ENDM                                                            ;

IRP             x,<0,1,3,4,5,6,7,16,18,19>                      ; exceptions without
                public  trap_&x                                 ; error code
trap_&x:
                push    0                                       ; simulate zero code
                push    x                                       ;
                jmp     common_trap                             ;
ENDM

                public  timer_irq, iretq_addr
timer_irq:
                push    0                                       ;
                push    256                                     ;
                jmp     common_trap                             ;
;
; save registers in own static buffer...
; this method is dumb, but we can`t set TSS because we can`t reset it on exit
; if Task Register was 0.
;                
common_trap:                                                    ;
                push    r15                                     ;
                mov     r15,rsp                                 ;
                cli                                             ;
                mov     rsp,XcptStack                           ;
                push    [r15+7*8]                               ; ss
                push    [r15+6*8]                               ; rsp
                push    [r15+5*8]                               ; rflags
                push    [r15+4*8]                               ; cs
                push    [r15+3*8]                               ; rip
                push    [r15+2*8]                               ; code
                push    [r15+1*8]                               ; number
                push    [r15+0*8]                               ; r15
                push    r14                                     ;
                push    r13                                     ;
                push    r12                                     ;
                push    r11                                     ;
                push    r10                                     ;
                push    r9                                      ;
                push    r8                                      ;
                push    rbp                                     ;
                push    rdi                                     ;
                push    rsi                                     ;
                push    rdx                                     ;
                push    rcx                                     ;
                push    rbx                                     ;
                push    rax                                     ;
                push    gs                                      ;
                push    fs                                      ;
                xor     rax,rax                                 ;
                mov     rax,es                                  ;
                push    rax                                     ;
                mov     rax,ds                                  ;
                push    rax                                     ;
                mov     rax,cr4                                 ;
                push    rax                                     ;
                mov     rax,cr3                                 ;
                push    rax                                     ;
                mov     rax,cr2                                 ;
                push    rax                                     ;
                mov     rax,cr0                                 ;
                push    rax                                     ;

                mov     ss,word ptr Stack32+4                   ;
                jmp     fword ptr [Xcpt64Addr]                  ; go back home! :)

                public  XcptRet32                               ;
XcptRet32:
                xor     rcx,rcx                                 ;
                dec     ecx                                     ; just make sure
                and     rsp,rcx                                 ;
                add     rsp,24                                  ; skip cr0,2,3
                pop     rax                                     ;
;                mov     cr4,rax                                 ; but restore cr4
                pop     rax                                     ;
                mov     ds,rax                                  ;
                pop     rax                                     ;
                mov     es,rax                                  ;
                pop     fs                                      ;
                pop     gs                                      ;
                pop     rax                                     ;
                pop     rbx                                     ;
                pop     rcx                                     ;
                pop     rdx                                     ;
                pop     rsi                                     ;
                pop     rdi                                     ;
                pop     rbp                                     ;
                pop     r8                                      ;
                pop     r9                                      ;
                pop     r10                                     ;
                pop     r11                                     ;
                pop     r12                                     ;
                pop     r13                                     ;
                pop     r14                                     ;
                pop     r15                                     ;
                add     rsp,16                                  ;
iretq_addr:
                iretq                                           ;  ss:rsp & flags restored here

                end
