#!/bin/sh
# ***************************************************
# * make            - build all projects            *
# * make clean      - clean all projects            *
# * make prj        - build single project          *
# * make prj xx     - build single project`s target *
# ***************************************************

# setup variables
. ../../setup.sh

build_all=1

# echo "'$1'"

if [ "$1" != "clean" ]
then
  if test -n "$1"
  then
    build_all=0
  fi
fi

if [ "$build_all" = "1" ]
then
  bldparm=$1
  # ------- add project here -------
  bash -c "./make.sh libefi   $bldparm"
else
  if test -f $1/$1.prj
  then
    # ----- single project build -----
    cd $1
    # writing makefile for reference
    spprj -nb $1.prj $EFICC bld/$1.mak
    # and build it
    bldarg=$2
    if test -z $bldarg
    then
      bldarg=\*
    fi
    spprj -b -bl -w $BCKEY -es $1.prj $EFICC "$bldarg"
    cd ..
  else
    echo Project \"$1\" is not exist!
  fi
fi
